<?php
/* **************************************************************************** *

 * cor-add-user.php								*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 Page for adding users.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class addUser {

    public $page = array ();

    public function __construct ()
    {

	if ( isset ( $_POST [ "nick" ], $_POST [ "fullname" ], $_POST [ "password" ], $_POST [ "password2" ], $_POST [ "usergroup" ], $_POST [ "language" ]  ) ) {
	    $this -> page [ "text" ] .= self::addNewUser ();
	    $this -> page [ "text" ] .= '<img src="images/users-icons/free-icons/blue-user-big.jpg" alt="'. _( "Modrá uživatelská ikona" ) .'" />
	    <hr class="cleaner" /><input type="button" class="dialogue-button" onclick="location.reload(true);" value="'. _( "Zavřít" ) .'" />';
	} else {
	    $this -> page [ "text" ] .= self::addUserForm ();
	}

    } // end __construct

    public static function addUserForm ()
    {

    	$password = md5 ( $_POST [ "pass" ] );
    	$nick = htmlspecialchars ( $_POST [ "nick" ] );
    	$fullname = htmlspecialchars ( $_POST [ "fullname" ] );
    	$language = htmlspecialchars ( $_POST [ "language" ] );
    	$usergroup = (int) $_POST [ "usergroup" ];

	$form .= '
	<form action="'. Tools::getFullPage () .'" method="post" id="CreateUserForm" enctype="application/x-www-form-urlencoded">
	    	<fieldset>
     	    	    <legend>'. _( "Vytvoření nového uživatele" ) .'</legend>
     	    	    <label for="nick">'. _( "Přezdívka" ) .': </label><input type="text" name="nick" maxlength="20" value="'. $nick .'" /><br />
     	    	    <label for="fullname">'. _( "Občanské jméno" ) .': </label><input type="text" name="fullname" maxlength="40" value="'. $fullname .'" /><br />
             	    <label for="password">'. _( "Heslo" ) .': </label><input type="password" size="15" name="password" maxlength="25" onkeyup="passwordStrength(this.value,\'passwordStrength\');" /><br />
             	    <span id="passwordStrength" class="floatLeft">'. _( "Zde bude zobrazeno hodnocení síly hesla" ) .'</span><br />
             	    <label for="password2">'. _( "Ověření hesla" ) .': </label><input type="password" size="15" name="password2" maxlength="25" /><br />';

	if ( isset ( $_GET [ "primarygroupid" ] ) || isset ( $_GET [ "usergroupid" ] ) ) {
	    if ( User::session () -> getPrimaryGroup () > ( (int) $_GET [ "primarygroupid" ] ) )
	    	Error::ticket () -> notice ( 'cor00032', 'in '.__FILE__.' on line '.__LINE__, User::session () -> getId () );
	    $form .= '<input type="hidden" name="usergroup" value="'. (int) $_GET [ "primarygroupid" ] .'" />
	              <input type="hidden" name="secondaryusergroup" value="'. (int) $_GET [ "usergroupid" ] .'" />';
	} else {
	    $form .= '<label for="usergroup">'. _( 'Skupina' ) .': </label>
	    	<select name="usergroup">';

		$primaryGroup = User::session () -> getPrimaryGroup ();
		if ( $primaryGroup == 1 ) $form .= '<option value="1">'. _( "Administrátoři" ) .'</option>';
		if ( $primaryGroup <= 2 ) $form .= '<option value="2">'. _( "Webmasteři" ) .'</option>';
		if ( $primaryGroup <= 3 ) $form .= '<option value="3">'. _( "Spisovatelé" ) .'</option>';
		if ( $primaryGroup <= 4 ) $form .= '<option value="4">'. _( "Uživatelé" ) .'</option>';

	    $form .= '</select><br />';
	}

        $form .= '<label for="language">'. ( "Jazyk" ) .': </label><select name="language">
             	    	<option value="cs"'. ( ( $language == "cs" ) ? " selected=\"selected\"" : "" ) .'>čeština</option>
             	    </select><br />
             	    <input type="submit" value="'. ( "Vytvořit uživatele" ) .'" onclick="changeDialogueByPost(\''. Tools::getPage () .'.xml\',\'CreateUserForm\');return false;" />
             	</fieldset>
	    </form>';

	return $form;

    } // end addUserForm

    public static function addNewUser ()
    {
    	if ( empty ( $_POST [ "nick" ] ) || empty ( $_POST [ "password" ] ) || empty ( $_POST [ "password2" ] ) ) {
    	    return '<p><strong class="warning">'. _( "Jedno nebo více z políček Nick, Heslo nebo Ověření hesla nebylo vyplněno." ) .'</strong></p>';
    	}

    	if ( strlen ( $_POST [ "password" ] ) < 6 ) {
    	    return '<p><strong class="warning">'. _( "Délka hesla musí být minimálně 6 znaků." ) .'</strong></p>';
    	}
    	
    	if ( $_POST [ "password" ] != $_POST [ "password2" ] ) {
    	    Error::ticket () -> notice ( 'cor00017', 'in '.__FILE__.' on line '.__LINE__, $nick );
    	    return false;
    	}
    	
    	$password = md5 ( addslashes ( $_POST [ "password" ] ) );
    	$nick = htmlspecialchars ( $_POST [ "nick" ] );
    	$fullname = htmlspecialchars ( $_POST [ "fullname" ] );
    	$language = htmlspecialchars ( $_POST [ "language" ] );
    	$usergroup = (int) $_POST [ "usergroup" ];

	if ( User::session () -> getPrimaryGroup () > $usergroup )
	    	Error::ticket () -> notice ( 'cor00032', 'in '.__FILE__.' on line '.__LINE__, User::session () -> getId () );

    	if ( Database::connection () -> getResult ( "SELECT id FROM users WHERE nick='$nick';" ) ) {
    	    return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel s touto přezdívkou již v databázi existuje." ) .'</strong></p>';
    	}
    	
    	if ( Database::connection () -> query ( "INSERT INTO users VALUES (0, '$nick', '$password', '$fullname', CURRENT_TIMESTAMP (),  0, '$language');" ) ) {
    	    if ( Database::connection () -> query ( "INSERT INTO membersofgroups VALUES ( LAST_INSERT_ID(), $usergroup );" ) ) {
    	    	if ( isset ( $_POST [ "secondaryusergroup" ] ) ) {
    	    	   if ( Database::connection () -> query ( "INSERT INTO membersofgroups VALUES ( LAST_INSERT_ID(), ". (int) $_POST [ "secondaryusergroup" ] ." );" ) ) {
    	    	    	if ( !self::createUserMenu (  Database::connection () -> getResult ( "SELECT LAST_INSERT_ID();" ), (int) $_POST [ "secondaryusergroup" ] ) ) {
    	    	    	    return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel byl úspěšně vytvořen, ale nepodařilo se pro něj vytvořit menu. Bude pro něj proto použito defaultní menu jeho primární skupiny." ) .'</strong></p>';
    	    	    	} else {
    	    	    	    return '<p><strong class="success">'. $nick . ' - '. _( "uživatel byl úspěšně vytvořen") .'.</strong></p>';
    	    	    	}
    	    	    } else {
    	    	    	return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel vytvořen, ale nepodařilo se mu přiřadit sekundární uživatelskou skupinu. O problému uvědomte administrátora." ) .'</strong></p>';
    	    	    }
    	    	} else {
    	    	    if ( !self::createUserMenu (  Database::connection () -> getResult ( "SELECT LAST_INSERT_ID();" ), $usergroup ) ) {
    	    	    	return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel byl úspěšně vytvořen, ale nepodařilo se pro něj vytvořit menu. Bude pro něj proto použito defaultní menu jeho primární skupiny." ) .'</strong></p>';
    	    	    } else {
    	    	    	return '<p><strong class="success">'. $nick . ' - '. _( "uživatel byl úspěšně vytvořen") .'.</strong></p>';
    	    	    }
    	    	}
    	    } else {
    	    	return '<p><strong class="warning">'. $nick . ' - '. _( "uživatel vložen do databáze, ale nepodařilo se mu přiřadit uživatelskou skupinu" ) .'!</strong></p>';
    	    }
    	} else {
    	    Error::ticket () -> notice ( 'cor00018', 'in '.__FILE__.' on line '.__LINE__, $nick );
    	}
    } // end addNewUser

    public static function createUserMenu ( $userid, $groupid )
    {
    	$upmenu = Database::connection () -> fetchall_assoc ( "SELECT * FROM groupsappmenus WHERE groupid=$groupid;" );
    	foreach ( $upmenu as $menuIcon ) {
    	    if ( !Database::connection () -> query ( "INSERT INTO usersappmenus VALUES ($userid, '". $menuIcon [ "anchor" ] ."', '". $menuIcon [ "file" ] ."', '". $menuIcon [ "icon" ] ."', '". $menuIcon [ "sequence" ] ."');" ) ) {
    	    	@Database::connection () -> query ( "DELETE FROM usersappmenus WHERE userid=$userid;" );
    	    	return false;
    	    }
    	}
    	return true;
    }

}

$addUser = new addUser ();
$page = $addUser -> page;
?>