<?php
/* **************************************************************************** *

 * cor-download-stats.php							*
 * @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*
 
 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Page with statistics of web pages using Albireo.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class DownloadStats {

    public $page = array ( "text" => "" );

    public function __construct ()
    {

    	$this -> page [ "text" ] .= '<div class="actionbar"><h2>'. _( "10 nejstahovanějších souborů" ) .'</h2></div>';
    	$most_popular = Database::connection () -> fetchall_assoc ( "SELECT url, COUNT(url) FROM downloadstats GROUP BY url ORDER BY COUNT(url) DESC LIMIT 10" );
    	if ( is_array ( $most_popular ) ) {
	    $this -> page [ "text" ] .= '<table class="table">
	    <tr><th>'. _( "soubor" ) .'</th><th>'. _( "počet stažení" ) .'</th></tr>';
	    foreach ( $most_popular as $download ) {
	    	$this -> page [ "text" ] .= '<tr><td>'. $download [ "url" ] .'</td><td>'. $download [ "COUNT(url)" ] .'</td></tr>';
	    }
	    $this -> page [ "text" ] .= '</table>';
	} else {
	    $this -> page [ "text" ] .= _( "Žádný soubor ještě nebyl stažen." );
	}

    	$this -> page [ "text" ] .= '<div class="actionbar"><h2>'. _( "Posledních 10 stažení" ) .'</h2></div>';

	$lastdownloads = Database::connection () -> fetchall_assoc ( "SELECT * FROM downloadstats ORDER BY time DESC LIMIT 10" );
	if ( is_array ( $lastdownloads ) ) {
	    $this -> page [ "text" ] .= '<table class="table">
	    <tr><th>'. _( "Čas" ) .'</th><th>'. _( "soubor" ) .'</th><th>'. _( "uživatel" ) .'</th><th>'. _( "ip" ) .'</th><th>'. _( "agent" ) .'</th></tr>';
	    foreach ( $lastdownloads as $download ) {
	    	$user = Database::connection () -> fetch_assoc ( "SELECT * FROM users WHERE id=". $download [ "userid" ] .";" );
	    	$user_name = ( $user ) ? '<a href="#" onclick="ajaxDialogue(\''. Localization::session () -> getFile ( "cor-user-control" ) .'.xml?user='. $user [ "id" ] .'\');return false;" title="'. _( "Ukaž uživatele" ) .'">'. $user [ "nick" ] .'</a>' : _( "Neznámý" );
	    	
	    	$this -> page [ "text" ] .= '<tr><td>'. Tools::getRightDate ( $download [ "time" ], "full" ) .'</td><td>'. $download [ "url" ] .'</td><td>'. $user_name .'</td><td title="'. $download [ "host" ] .'">'. $download [ "ip" ] .'</td><td>'. $download [ "agent" ] .'</td></tr>';
	    }
	    $this -> page [ "text" ] .= '</table>';
	} else {
	    $this -> page [ "text" ] .= _( "Žádný soubor ještě nebyl stažen." );
	}

    } // end __construct

}

$DownloadStats = new DownloadStats ();
$page = $DownloadStats -> page;
?>