<?php
/* **************************************************************************** *

 * cor-download.php								*
 * @package	Core								*
 * @copyright	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*

 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Script for managing downloading files in Albireo.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class corDownload {

    public $page = array ();

    public function __construct ()
    {
	if ( isset ( $_GET [ "file" ] ) ) {
	    $this -> download ( $_GET [ "file" ] );
	} else {
	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nebyl definován soubor ke stažení!" ) .'</strong></p>';
	}
    } // end __construct

    private function download ( $file )
    {
    	if ( $file == "" && !file_exists ( $file ) ) {
    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Volaný soubor neexistuje!" ) .'</strong></p>';
    	    return;
    	}

    	if ( !( $downloadable = Database::connection () -> fetch_assoc ( "SELECT * FROM downloadable WHERE url='$file';" ) ) ||
    	     !SecurityTools::check_read ( $downloadable [ "access" ], $downloadable [ "author" ], $downloadable [ "groupid" ] ) ) {
    	    Error::ticket () -> notice ( 'cor00031', 'in ' .__FILE__. ' on line ' .__LINE__, addslashes ( "$file" ) ); // possible unautorized try to get system file
    	}

    	if ( !Database::connection () -> query ( "INSERT INTO downloadstats VALUES ('". $file ."', ". User::session () -> getId () .", '". $_SERVER [ "REMOTE_ADDR" ] ."', '". getHostByADDR ( $_SERVER [ "REMOTE_ADDR" ] ) ."', '". $_SERVER [ "HTTP_USER_AGENT" ] ."', CURRENT_TIMESTAMP () );" ) ) {
    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Do databáze nelze vložit záznam o stažení." ) .'</strong></p>';
    	    return;
    	}
    	
    	header ( "Content-Description: File Transfer" );
	header ( "Content-Type: application/force-download" );
	header ( "Content-Disposition: attachment; filename=\"$file\"" );

	readfile ( $file );

	exit;
    } // end download

}

$corDownload = new corDownload ();
$page = $corDownload -> page;
?>