<?php
/* **************************************************************************** *

 * cor-drive-contents.php							*
 * @package	Core								*
 * @copyright	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*

 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Script for managing files at drive.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */
require "cor-contents.php";

class DriveContents extends Contents {

    public $page = array ( "text" => "" );
    private $cordrive;
    private $corsourceeditor;

    public function __construct ()
    {
    	
    	$this -> cordrive = Localization::session () -> getFile ( "cor-drive", false );
    	$this -> corsourceeditor = Localization::session () -> getFile ( "cor-source-editor", false );
    	
    	if ( isset ( $_GET [ "contentdir" ], $_GET [ "side" ] ) && ( $_GET [ "side" ] == "left" || $_GET [ "side" ] == "right" )  ) {
    	    $this -> page [ "text" ] .= $this -> showDir ( $_GET [ "contentdir" ], $_GET [ "side" ] );
    	} else {

	    // gets php code common to all pages of contents
    	    parent::__construct ();

    	    $this -> page [ "text" ] .= '<br /><strong>'. _( "Místo na disku" ) .':</strong> '. (int) ( disk_free_space ( "." ) / 1000000 ) .' MB '. _( "z" ) .' '. (int) ( disk_total_space ( "." ) / 1000000 ) .' MB';

	    // uploads file on server
    	    if ( isset ( $_FILES [ "file" ], $_POST [ "access" ], $_POST [ "usergroup" ], $_POST [ "access" ], $_POST [ "parent" ] ) ) {
    	    	$this -> uploadFile ();
    	    	$this -> page [ "text" ] .= '<script type="text/javascript">
	    	    showAndHide ( \'upload\' );
	    	</script>';
    	    }

	    $this -> page [ "text" ] .= '
	    <script type="text/javascript" src="scripts/cor-source-editor.js"></script>
	    <div class="floatLeft">
	    <a href="#" class="cor-button-small cor-upload" onclick="directoryContent.destroyObjectActions();ajaxDialogue(\''. $this -> cordrive .'.xml?action=upload&#038;dirid=\'+directoryContent.leftDirId);return false;"><span>'. _( 'Nahrát' ) .'</span></a><br />
	    <a href="#" class="cor-button-small cor-createfile" onclick="directoryContent.destroyObjectActions();ajaxDialogue(\''. $this -> cordrive .'.xml?action=createfile&#038;dirid=\'+directoryContent.leftDirId);return false;"><span>'. _( 'Vytvořit' ) .'</span></a><br />
	    <a href="#" class="cor-button-small cor-foldernew" onclick="directoryContent.destroyObjectActions();ajaxDialogue(\''. $this -> cordrive .'.xml?action=newfolder&#038;dirid=\'+directoryContent.leftDirId);return false;"><span>'. _( 'Nová složka' ) .'</span></a>
	    </div>

	    <div class="floatRight">
    	    <a href="#" class="cor-button-small cor-upload" onclick="directoryContent.destroyObjectActions();ajaxDialogue(\''. $this -> cordrive .'.xml?action=upload&#038;dirid=\'+directoryContent.rightDirId);return false;"><span>'. _( 'Nahrát' ) .'</span></a><br />
    	    <a href="#" class="cor-button-small cor-createfile" onclick="directoryContent.destroyObjectActions();ajaxDialogue(\''. $this -> cordrive .'.xml?action=createfile&#038;dirid=\'+directoryContent.rightDirId);return false;"><span>'. _( 'Vytvořit' ) .'</span></a><br />
    	    <a href="#" class="cor-button-small cor-foldernew" onclick="directoryContent.destroyObjectActions();ajaxDialogue(\''. $this -> cordrive .'.xml?action=newfolder&#038;dirid=\'+directoryContent.rightDirId);return false;"><span>'. _( 'Nová složka' ) .'</span></a>
    	    </div>';

	    $this -> page [ "text" ] .= '
    	    <div id="cor-contentdir-head" onclick="directoryContent.destroyObjectActions();">
    	    <div class="floatLeft cor-contentdir"><div id="leftContentWindow">'. $this -> showDir ( "root", "left" ) .'</div></div>
    	    <div class="floatRight cor-contentdir"><div id="rightContentWindow">'. $this -> showDir ( "root", "right" ) .'</div></div>
    	    </div>

    	    <img class="invisible" src="styles/cor-admin/folder_open.jpg" alt="hidden part of content" />
    	    <img class="invisible" src="styles/cor-admin/createfile-over.jpg" alt="hidden part of content" />
    	    <img class="invisible" src="styles/cor-admin/upload-over.jpg" alt="hidden part of content" />
    	    <script type="text/javascript">
    	    	// sets main directory as root (user can`t create anything in root diretory)
    	    	directoryContent.leftDirId = "root";
    	    	directoryContent.rightDirId = "root";
    	    </script>
    	    <hr class="cleaner" />';

    	}
    } // end __construct

    private function showDir ( $dir, $side )
    {
    	$content = "";

    	if ( $dir == "root" ) {
    	    $directory = Database::connection () -> fetchall_assoc ( "SELECT * FROM drivefiles WHERE parent='root';" );
    	    $directory [ 0 ] [ "title" ] = "Obrázky";
    	    $directory [ 1 ] [ "title" ] = "XHTML";
    	    $directory [ 2 ] [ "title" ] = "Styly";

    	    foreach ( $directory as $folder ) {
	    	$content .= $this -> createHTMLDir ( $folder, $dir, $side );
	    }
    	} else {
    	    $parent_dir = Database::connection () -> fetch_assoc ( "SELECT parent, access, author, groupid FROM drivefiles WHERE physicalname='$dir';" );
    	    $parent_dir = ( is_array ( $parent_dir ) ) ? $parent_dir : array ( "author" => 1, "groupid" => 1, "access" => "ww0", "parent" => "root" );
    	    // access checking ///////////////////////////////////////////////////////////
	    if ( $dirNumber != "root" ) {
	    	if ( !SecurityTools::check_read ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
	    	    Error::ticket () -> notice ( 'cor00028', 'in '. __FILE__ .' on line '. __LINE__ , Tools::getFullPage () ." ". User::session () -> getNick () );
	    	}
	    }
	    //////////////////////////////////////////////////////////////////////////////
    	    $content = '<a href="#" class="cor-button cor-dirButton" onclick="return false;" oncontextmenu="return false;" ondblclick="directoryContent.getDirectoryContent(\'xml.php?page='. Tools::getPage () .'&#038;contentdir='. $parent_dir [ "parent" ] .'&#038;side='. $side. '\',\''. $side .'\',\''. $parent_dir [ "parent" ] .'\');"><span>'. _( '..nahoru' ) .'</span></a>';
    	    $content .= $this -> readFolder ( $dir, $side );
    	}

    	return $content;
    } // end showDir

    private function readFolder ( $dir, $side ) {

	$path = $dir;
	$folder = "";

	if ( $path != "root" ) {
	    $parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$dir';" );
    	    while ( $parent != "root" && $parent != "" ) {
    	    	$path = $parent ."/". $path;
    	    	$parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$parent';" );
    	    }
   	}

	$directory = opendir ( $path );
	$folders = array ();
	$files = array ();

    	while ( $file = readdir ( $directory ) ) {
    	     if ( $file != "." && $file != ".." ) {
    	     	if ( is_dir ( $path . "/" . $file ) ) {
    	     	    $folders [] = $file;
    	     	} else {
    	     	    $files [] = $file;
    	     	}
    	     }
    	}

    	closedir ( $directory );
    	sort ( $folders );
    	sort ( $files );

    	foreach ( $folders as $this_folder ) {
    	    $row = Database::connection () -> fetch_assoc ( "SELECT * FROM drivefiles WHERE physicalname='$this_folder';" );
    	    $data = ( is_array ( $row ) ) ? $row : array ( "author" => 1, "groupid" => 1, "access" => "ww0", "physicalname" => $this_folder );
    	    $folder .= $this -> createHTMLDir ( $data, $dir, $side );
    	}

    	foreach ( $files as $this_file ) {
    	    $row = Database::connection () -> fetch_assoc ( "SELECT * FROM drivefiles WHERE physicalname='$this_file';" );
    	    $data = ( is_array ( $row ) ) ? $row : array ( "author" => 1, "groupid" => 1, "access" => "ww0", "physicalname" => $this_file );
    	    $folder .= $this -> createHTMLFile ( $data, $dir, $side, $path );
    	}

    	return $folder;
    } // end readFolders

    private function createHTMLFile ( $file, $parent, $side, $fold )
    {
    	if ( !SecurityTools::check_read ( $file [ "access" ], $file [ "author" ], $file [ "groupid" ] ) ) {
    	    return; // user doesn`t have permission to read this article
    	}
    	$file_title = ( isset ( $file [ "title" ] ) ) ? $file [ "title" ] : $file [ "physicalname" ];
    	$title = ( strlen ( $file_title ) > 28 || ( strlen ( $file_title ) > 14 && stripos ( substr ( $file_title, 0, 12 ), " " ) === false ) ) ? substr ( $file_title, 0, 11 ) ."..." : $file_title;

    	$type = substr ( strrchr ( $file_title, "." ), 1 ); // find type of file
    	if ( $type == "php" || $type == "bak" ) return;

	$class = ""; // css class of button
	$action = ""; // javascript action for button
    	
    	switch ( $type ) {
    	    case "jpg":
    	    case "gif":
    	    case "png":
    	    case "ico":
    	    case "bmp":
    	    	$class = "imageFile";
    	    	$action = "ajaxDialogue('". $this -> cordrive .".xml?action=image&#038;src=$fold/$file_title');";
    	    	break;
    	    case "css":
    	    	$class = "cssFile";
    	    	$action = "ajaxDialogue('". $this -> corsourceeditor .".xml?src=$fold/$file_title');resizeDialogue();";
    	    	break;
    	    case "html":
    	    	$class = "htmlFile";
    	    	$action = "ajaxDialogue('". $this -> corsourceeditor .".xml?src=$fold/$file_title');resizeDialogue();";
    	    	break;
    	    default:
    	    	$class = "unknownFile";
    	}

    	return '<a href="#" class="cor-button cor-'. $class .'" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'file\',\''. $file [ "physicalname" ] .'\',\''. $this -> cordrive .'\');return false;" ondblclick="'. $action .'" title="'. $file_title .'"><span>'. $title .'</span></a>';
    } // end createHTMLFile

    private function createHTMLDir ( $folder, $parent, $side )
    {
	if ( !SecurityTools::check_read ( $folder [ "access" ], $folder [ "author" ], $folder [ "groupid" ] ) ) {
    	    return; // user doesn`t have permission to read this article
    	}
    	$folder_title = ( isset ( $folder [ "title" ] ) ) ? $folder [ "title" ] : $folder [ "physicalname" ];
    	$title = ( strlen ( $folder_title ) > 28 || ( strlen ( $folder_title ) > 14 && stripos ( substr ( $folder_title, 0, 12 ), " " ) === false ) ) ? substr ( $folder_title, 0, 11 ) ."..." : $folder_title;
	return '<a href="#" class="cor-button cor-dirButton" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'directory\',\''. $folder [ "physicalname" ] .'\',\''. $this -> cordrive .'\');return false;" title="'. $folder_title .'" ondblclick="directoryContent.getDirectoryContent(\''. Tools::getPage () .'.xml?contentdir='. $folder [ "physicalname" ] .'&#038;side='. $side. '\',\''. $side .'\',\''. $folder [ "physicalname" ] .'\');"><span>'. $title .'</span></a>';

    } // end createHTMLDir

    private function uploadFile ()
    {

    	if ( !isset ( $_POST [ "parent" ] ) || $_POST [ "parent" ] == "root" ) {
	    $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Nelze nahrávat soubory do kořenového adresáře!" ) .'</strong></p>';
	    return;
	}

	$parent_dir = Database::connection () -> fetch_assoc ( "SELECT physicalname, author, groupid, access FROM drivefiles WHERE physicalname='". addslashes ( $_POST [ "parent" ] ) ."';" );

	// if folder isn`t defined in database, we don`t allow you to write in
	if ( !is_array ( $parent_dir ) ) {
	    $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
	    return;
	}

	// access checking ///////////////////////////////////////////////////////////
	if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
	    $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

    	$files = $_FILES [ "file" ];
    	$physicalname = htmlspecialchars ( $files [ "name" ] );
    	$access = htmlspecialchars ( $_POST [ "access" ] );
	$group = (int) $_POST [ "usergroup" ];
	$fileparent = htmlspecialchars ( $_POST [ "parent" ] );

	if ( $physicalname == "root" ) {
	    $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Soubor se nemůže jmenovat root!" ) .'!</strong></p>';
	    return;
	}

	// nobody can upload php files ///////////////////////////////////////////////
	if ( !$this -> checkFileType ( $physicalname ) ) {
	    $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Albireo rozpoznalo nahrávaný soubor jako potenciální PHP skript, který by mohl poškodit systém. Náhrání tohoto souboru nebude povoleno" ) .'!</strong></p>';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

	if ( Database::connection () -> getResult ( "SELECT physicalname FROM drivefiles WHERE physicalname='$physicalname';" ) ) {
	    $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Soubor tohoto jména už existuje!" ) .'!</strong></p>';
	    return;
	}

	$path = htmlspecialchars ( $_POST [ "parent" ] ) ."/";
	$parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='". addslashes ( $_POST [ "parent" ] ) ."';" );
	while ( $parent != "root" ) {
    	    $path = $parent. "/" .$path;
    	    $parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$parent';" );
    	}

    	if ( $physicalname == "" ) {
    	    $this -> page [ "text" ] .= '<p><strong class="warning" id="upload">'. _( "Soubor nemá název!" ) .'</strong></p>';
    	    return;
    	}

	$type = substr ( strrchr ( $physicalname, "." ), 1 );

	if ( @move_uploaded_file ( $files [ "tmp_name" ],  $path . $physicalname ) ) {
	    if ( $type != "zip" ) {
	    	if ( Database::connection () -> query ( "INSERT INTO drivefiles VALUES ( '$physicalname', ". User::session () -> getId () .", '$group', '$access', '$fileparent' );" ) ) {
	    	    $this -> page [ "text" ] .= '
	    	    <p class="success" id="upload">'. $path . $physicalname .' ('. $files [ "type" ] .' - '. (int) ( $files[ "size" ] / 1024 ) .'kB) - '. _( "Soubor byl úspěšně nahrán na server." ) .'</p>';
	    	} else {
	    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Soubor byl nahrán na server, ale nepodařilo se vytvořit záznam v databázi!" ) .'</strong></p>';
	    	}
	    }
	} else {
	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se nahrát soubor na server!" ) .'</strong></p>';
	    return;
	}

	if ( $type == "zip" ) {
	    chdir ( $path );
	    $zip = new ZipArchive;
            if ( @$zip -> open ( $physicalname ) === true ) {
            	$zip -> extractTo ( "." );
            	$i = 0;
            	$this -> page [ "text" ] .= '<div id="upload">';
            	$zip_files = array ();
            	while ( $zip -> getNameIndex ( $i ) ) {
            	    $filename = $zip -> getNameIndex ( $i );
            	    if ( !$this -> checkFileType ( $filename ) ) {
	    		$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Albireo rozpoznalo nahrávaný soubor jako potenciální hrozbu, který by mohla poškodit systém. Náhrání tohoto souboru nebude povoleno" ) .'!</strong></p>';
	    		@unlink ( $filename );
	    	    } else {
	    	    	$zip_files [] = $filename;
	    	    }
	    	    ++$i;
           	}
           	$zip -> close ();
            	@unlink ( $physicalname );
            	$userid = User::session () -> getId ();
            	@set_time_limit ( 0 );
            	foreach ( $zip_files as $file ) {
            	    if ( Database::connection () -> query ( "INSERT INTO drivefiles VALUES ( '$file', $userid, $group, '$access', '$fileparent' );" ) ) {
            	    	$this -> page [ "text" ] .= '<strong class="success">'. $path . $file .' - '. _( "Soubor byl úspěšně nahrán na server." ) .'</strong><br />';
            	    }
            	}
           	$this -> page [ "text" ] .= '</div>';

            } else {
            	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se rozbalit ZIP archiv!" ) .'</strong></p>';
            }
	    $number_of_depth = substr_count ( $path, "/" );
	    for ( $i = 0; $i < $number_of_depth; $i++ ) {
	    	chdir ( ".." );
	    }
	}
    } // end uploadFile

    private function checkFileType ( $physicalname )
    {
    	$type = substr ( strrchr ( $physicalname, "." ), 1 ); // find type of file
    	if ( $type == "" || substr ( $type, 0, 3 ) == "php" || $type == "phtml" ) {
    	    return false;
    	} else {
    	    return true;
    	}
    } // end checkFileType

}

$DriveContents = new DriveContents ();
$page = $DriveContents -> page;
?>