<?php
/* **************************************************************************** *

 * cor-articles.php								*
 * @package	Core								*
 * @copyright	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*

 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Page for managing articles of Albireo.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class Drive {

    public $page = array ();

    public function __construct ()
    {
    	
    	switch ( $_REQUEST [ "action" ] ) {
    	    case "createThisFile":
    	    	$this -> createThisFile ();
    	    	break;
    	    case "createfile":
    	    	$this -> createFile ();
    	    	break;
    	    case "newfolder":
    	    	$this -> folderEditor ();
    	    	break;
    	    case "createfolder":
    	    	$this -> createFolder ();
    	    	break;
    	    case "image":
    	    	$this -> showImage ();
    	    	break;
    	    case "upload":
    	    	$this -> uploadForm ();
    	    	break;
    	    case "copy":
		$this -> copyIt ();
    	    	break;
    	    case "move":
    	    	$this -> moveIt ();
    	    	break;
    	    case "delete1":
    	    	$this -> reallyDelete ();
    	    	break;
    	    case "delete2":
    	    	$this -> deleteIt ();
    	    	break;
    	    case "editfile":
    	    case "showdirinfo":
    	    	$this -> editFile ();
    	    	break;
    	}
    } // end __construct

    private function createThisFile ()
    {
    	$this -> page [ "title" ] = _( "Nová složka" );

	if ( empty  ( $_POST [ "parent" ] ) || $_POST [ "parent" ] == "root" ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze vytvářet nové složky v kořenovém adresáři!" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	$parent_dir = Database::connection () -> fetch_assoc ( "SELECT physicalname, author, groupid, access FROM drivefiles WHERE physicalname='". addslashes ( $_POST [ "parent" ] ) ."';" );

	if ( $parent_dir [ "physicalname" ] != "bodies" &&
	     $parent_dir [ "physicalname" ] != "headers" &&
	     $parent_dir [ "physicalname" ] != "styles" ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubory je možné vytvářet jen ve složkách xhtml/headers, xhtml/bodies a styles." ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	if ( $parent_dir [ "physicalname" ] == "bodies" ) {
	    $type = "html";
	    $Filetext =
' <body>
     <!-- '. _( "Zde vložte XHTML kód pro šablonu webové stránky. Rozšiřující XML značky naleznete na www.albireo.name. Konečnou šablonu pak připojte ke složce ve správě obsahu webu." ) .' --!>
 </body>';
	} elseif ( $parent_dir [ "physicalname" ] == "headers" ) {
	    $type = "html";
	    $Filetext =
' <head>
     <meta http-equiv="Content-Type" content="application/xhtml+xml; charset=UTF-8" />
     <meta http-equiv="Content-Language" content="'. _( "cs" ) .'" />
     <meta http-equiv="Cache-Control" content="no-cache" />
     <meta http-equiv="content-script-type" content="text/JavaScript" />
     <meta http-equiv="content-style-type" content="text/css" />
     <meta name="copyright" content="copyright '. date ( "Y" ) .' '. _( "Vaše firma" ) .'" />
     <meta name="author" content="all: '. _( "Autor; autor@e-mail.tld" ) .'" />
     <title>'. _( "Titulek stránky" ) .'</title>
     <link rel="stylesheet" type="text/css" href="styles/'. _( "vas-soubor-se-stylem" ) .'.css" charset="UTF-8" media="screen" />
     <!--[if IE ]>
  	 <link rel="stylesheet" type="text/css" href="styles/'. _( "vas-soubor-se-stylem-pro-msie" ) .'.css" charset="UTF-8" media="screen" />
     <![endif]-->
     <link rel="icon" href="favicon.ico" type="image/x-icon" />
     <link rel="shortcut icon" href="favicon.ico" type="image/x-icon" />
 </head>';
	} else {
	    $type = "css";
	    $Filetext = '/* '. _( "Zde vytvořte kód pro externí CSS styl. Ten nezapomeňte do jedné z šablon v xhtml/headers připojit tagem:" ) .' <link rel="stylesheet" type="text/css" href="styles/'. _( "vas-soubor-se-stylem" ) .'.css" charset="UTF-8" media="screen" /> */';
	}

	// if folder isn`t defined in database, we don`t allow to write in
	if ( !is_array ( $parent_dir ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	// access checking ///////////////////////////////////////////////////////////
	if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

	$physicalname = htmlspecialchars ( $_POST [ "title" ] );
	$access = htmlspecialchars ( $_POST [ "access" ] );
	$group = (int) $_POST [ "usergroup" ];
	$fileparent = htmlspecialchars ( $_POST [ "parent" ] );

	if ( $physicalname == "root" ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubor se nemůže jmenovat root!" ) .'!</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	if ( $text = $this -> check_duplicity ( $physicalname ) ) { // there is some duplicity in database
    	    $this -> page [ "text" ] .= $text;
    	    return;
    	}

	$path = htmlspecialchars ( $_POST [ "parent" ] ) ."/";
	$parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='". addslashes ( $_POST [ "parent" ] ) ."';" );
	while ( $parent != "root" ) {
    	    $path = $parent. "/" .$path;
    	    $parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$parent';" );
    	}

	$path .= "$physicalname";
	if ( @file_put_contents ( $path .'.'. $type, $Filetext ) ) {
	    if ( Database::connection () -> query ( "INSERT INTO drivefiles VALUES ( '$physicalname.$type', ". User::session () -> getId () .", '$group', '$access', '$fileparent' );" ) ) {
	    	$this -> page [ "text" ] = '<p>'. $physicalname . _( " - soubor úspěšně vytvořen." ) .'</p>';
	    } else {
	    	$this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nepodařilo se vytvořit záznam o souboru v databázi, ten se však na disku již nachází!" ) .'</strong></p>';
	    }
	} else {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Albireo nemohlo zapsat soubor na disk" ) .': '. $path .'</strong></p>';
	}
	$this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    }  // end createThisFile

    private function createFile ()
    {
    	$this -> page [ "title" ] = _( "Vytvořit soubor" );

	if ( empty  ( $_GET [ "dirid" ] ) || $_GET [ "dirid" ] == "root" ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze vytvářet nové soubory v kořenovém adresáři!" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	$parent_dir = Database::connection () -> fetch_assoc ( "SELECT physicalname, author, groupid, access FROM drivefiles WHERE physicalname='". addslashes ( $_GET [ "dirid" ] ) ."';" );

	if ( $parent_dir [ "physicalname" ] != "bodies" &&
	     $parent_dir [ "physicalname" ] != "headers" &&
	     $parent_dir [ "physicalname" ] != "styles" ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubory je možné vytvářet jen ve složkách xhtml/headers, xhtml/bodies a styles." ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	if ( $parent_dir [ "physicalname" ] == "bodies"  || $parent_dir [ "physicalname" ] == "headers" ) {
	    $type = "html";
	} else {
	    $type = "css";
	}

	// if folder isn`t defined in database, we don`t allow to write in
	if ( !is_array ( $parent_dir ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	// access checking ///////////////////////////////////////////////////////////
	if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

	$this -> page [ "text" ] = '
	<form action="xml.php?page='. Tools::getPage () .'" id="CreateFileForm" method="post" enctype="application/x-www-form-urlencoded">
	    <fieldset>
	    	<label for="title">'. _( 'Jméno' ) .': </label><input type="text" name="title" maxlength="50" />.'. $type .'<br />
	    	<label for="access">'. _( 'Přístup' ) .': </label>
		<select name="access" onchange="changeAccessInformation(this.value,\'accessInformation\');";>
	    	    <option value="wwr">'. _( "Veřejný" ) .'</option>
	    	    <option value="ww0">'. _( "Skupinový" ) .'</option>
	    	    <option value="wrr" selected="selected">'. _( "Chráněný" ) .'</option>
	    	    <option value="wr0">'. _( "Soukromý" ) .'</option>
	    	    <option value="w00">'. _( "Zabezpečený" ) .'</option>
	    	</select><br />
	    	<span id="accessInformation" class="floatLeft"><strong>'. _( "Autor může zapisovat, skupina může zapisovat a ostatní nemohou nic." ) .'</strong></span><br />
	    	<label for="usergroup">'. _( 'Skupina' ) .': </label>
	    	<select name="usergroup">';
	if ( User::session () -> getPrimaryGroup () >= 3 ) {
	     $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups WHERE id IN (SELECT groupid FROM membersofgroups WHERE userid=". User::session () -> getId () .");" );
	     foreach ( $usergroups as $group ) {
	   	$this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'"'. ( ( $article [ "groupid" ] == $group [ "id" ] ) ? " selected=\"selected\"" : "" ) .'>'. $group [ "usergroup" ] .'</option>';
	     }
	     if ( User::session () -> getPrimaryGroup () ) $this -> page [ "text" ] .= '<option value="4">'. _( "Uživatelé" ) .'</option>';
	} else {
	     $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups;" );
	     if ( User::session () -> getPrimaryGroup () == 2 ) unset ( $usergroups [ 0 ] );
	     foreach ( $usergroups as $group ) {
	   	$this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'">'. $group [ "usergroup" ] .'</option>';
	     }
	}
	$this -> page [ "text" ] .= '</select><br />
	    	<input type="hidden" name="parent" value="'. htmlspecialchars ( $_GET [ "dirid" ] ) .'" />
	    	'. _( "Rodičovská složka" ) . ': <strong>'. $parent_dir [ "physicalname" ] .'</strong><br />
	    	<input type="submit" value="'. _( "Vytvořit" ) .'" onclick="changeDialogueByPost(\''. Tools::getPage () .'.xml?action=createThisFile\',\'CreateFileForm\');return false;" />
	    </fieldset>
	</form>';

    } // end createFile

    private function editFile ()
    {

    	$physicalname = !empty  ( $_GET [ "physicalname" ] ) ? htmlspecialchars ( $_GET [ "physicalname" ] ) : ( ( !empty ( $_GET [ "id" ] ) ) ? htmlspecialchars ( $_GET [ "id" ] ) : htmlspecialchars ( $_POST [ "file" ] ) );

    	$this -> page [ "title" ] = _( "Editovat soubor" );

    	// access checking ///////////////////////////////////////////////////////////
	if ( ! ( $file = Database::connection () -> fetch_assoc ( "SELECT * FROM drivefiles WHERE physicalname='$physicalname';" ) ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubor nemá předobraz v databázi" ) .'!</strong></p>';
	    return;
	}
	if ( !SecurityTools::check_write ( $file [ "access" ], $file [ "author" ], $file [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povoleno mazání tohoto souboru" ) .'!</strong></p>';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

	if ( !empty ( $_POST [ "physicalname" ] ) &&  !empty ( $_POST [ "access" ] ) && !empty ( $_POST [ "usergroup" ] ) && !empty ( $_POST [ "file" ] ) ) {
	    $newphysicalname = htmlspecialchars ( $_POST [ "physicalname" ] );
	    $access = htmlspecialchars ( $_POST [ "access" ] );
	    $groupid = (int) $_POST [ "usergroup" ];

	    if ( $error = $this -> check_duplicity ( $newphysicalname, $file [ "parent" ] ) ) {
	    	$this -> page [ "text" ] .= $error;
	    	return;
	    }
	    
	    $fold_from = "";
	    $parent = $file [ "parent" ];
    	    while ( $parent != "root" && $parent != "" ) {
    	    	$fold_from = $parent ."/". $fold_from;
    	    	$parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$parent';" );
    	    }

    	    if ( rename ( $fold_from . $physicalname, $fold_from . $newphysicalname ) ) {
	    	if ( Database::connection () -> query ( "UPDATE drivefiles SET physicalname='$newphysicalname', access='$access', groupid=$groupid WHERE physicalname='$physicalname';" ) ) {
	    	    $this -> page [ "text" ] .= "<p>". _( "Soubor byl úspěšně editován." ) ."</p>";
	    	} else {
	    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se editovat soubor" ) .' '. $physicalname .'.</strong></p>';
	    	}
	    } else {
	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se fyzicky editovat soubor" ) .' '. $physicalname .'.</strong></p>';
	    }
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	$this -> page [ "text" ] = '
	<form action="'. Tools::getPage () .'.xml" id="EditorForm" method="post" enctype="application/x-www-form-urlencoded">
	    <fieldset>
	    	<label for="title">'. _( 'Jméno' ) .': </label><input type="text" name="physicalname" maxlength="50" value="'. $file [ "physicalname" ] .'" /><br />
	    	<label for="access">'. _( 'Přístup' ) .': </label>
	    	<select name="access" onchange="changeAccessInformation(this.value,\'accessInformation\');";>
	    	    <option value="wwr"'. ( ( $file [ "access" ] == "wwr" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Veřejný" ) .'</option>
	    	    <option value="ww0"'. ( ( $file [ "access" ] == "ww0" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Skupinový" ) .'</option>
	    	    <option value="wrr"'. ( ( $file [ "access" ] == "wrr" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Chráněný" ) .'</option>
	    	    <option value="wr0"'. ( ( $file [ "access" ] == "wr0" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Soukromý" ) .'</option>
	    	    <option value="w00"'. ( ( $file [ "access" ] == "w00" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Zabezpečený" ) .'</option>
	    	</select><br />';

	$accessInfo = "";
	switch ( $file [ "access" ] ) {
	    case 'ww0':
	    	$accessInfo = _( "Autor může zapisovat, skupina může zapisovat a ostatní nemohou nic." );
	    	break;
	    case 'wrr':
	    	$accessInfo = _( "Autor může zapisovat, skupina může číst a ostatní mohou také číst." );
	    	break;
	    case 'wr0':
	    	$accessInfo = _( "Autor může zapisovat, skupina může číst a ostatní nemohou nic." );
	    	break;
	    case 'w00':
	    	$accessInfo = _( "Autor může zapisovat, skupina nemůže nic a ostatní také nemohou nic." );
	    	break;
	    default:
	    	$accessInfo = _( "Autor může zapisovat, skupina může zapisovat a ostatní mohou číst." );
	        
	}
	$this -> page [ "text" ] .= '<span id="accessInformation" class="floatLeft"><strong>'. $accessInfo .'</strong></span><br />
	    	<label for="usergroup">'. _( 'Skupina' ) .': </label>
	    	<select name="usergroup">';
	if ( User::session () -> getPrimaryGroup () >= 3 ) {
	     $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups WHERE id IN (SELECT groupid FROM membersofgroups WHERE userid=". User::session () -> getId () .");" );
	     foreach ( $usergroups as $group ) {
	   	$this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'"'. ( ( $article [ "groupid" ] == $group [ "id" ] ) ? " selected=\"selected\"" : "" ) .'>'. $group [ "usergroup" ] .'</option>';
	     }
	     if ( User::session () -> getPrimaryGroup () ) $this -> page [ "text" ] .= '<option value="4">'. _( "Uživatelé" ) .'</option>';
	} else {
	     $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups;" );
	     if ( User::session () -> getPrimaryGroup () == 2 ) unset ( $usergroups [ 0 ] );
	     foreach ( $usergroups as $group ) {
	   	$this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'">'. $group [ "usergroup" ] .'</option>';
	     }
	}
	$this -> page [ "text" ] .= '</select><br />';
	if ( is_array ( $file ) ) {
	    $this -> page [ "text" ] .= '<input type="hidden" name="file" value="'. $file [ "physicalname" ] .'" />';
	}
	$this -> page [ "text" ] .= _( "Rodičovská složka" ) . ': <strong>'. $file [ "parent" ] .'</strong><br />
	    	<input type="submit" value="'. _( "Editovat" ) .'" onclick="changeDialogueByPost(\''. Tools::getPage () .'.xml?action=editfile\',\'EditorForm\');return false;" />
	    </fieldset>
	</form>';

    } // end editFile

    private function deleteIt ()
    {
    	$this -> page [ "title" ] = _( "Smazat" );

	$successfuldelete = "<p>". _( "Smazání proběhlo úspěšně." ) ."</p>";
	$unsuccessfuldelete = '<p><strong class="warning">'. _( "Smazání se nezdařilo." ) ."</strong>"."</p>";

	$physicalname = ( !empty  ( $_GET [ "file" ] ) ) ? htmlspecialchars ( $_GET [ "file" ] ) : htmlspecialchars ( $_GET [ "directory" ] );

	// access checking ///////////////////////////////////////////////////////////
	if ( ! ( $file = Database::connection () -> fetch_assoc ( "SELECT author, groupid, access FROM drivefiles WHERE physicalname='$physicalname';" ) ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubor nemá předobraz v databázi" ) .'!</strong></p>';
	    return;
	}
	if ( !SecurityTools::check_write ( $file [ "access" ], $file [ "author" ], $file [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povoleno mazání tohoto souboru" ) .'!</strong></p>';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

	$fold_from = "";
	$parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$physicalname';" );
    	while ( $parent != "root" && $parent != "" ) {
    	    $fold_from = $parent ."/". $fold_from;
    	    $parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$parent';" );
    	}

	if ( !empty  ( $_GET [ "file" ] ) ) {
	    if ( unlink ( $fold_from . $physicalname ) ) {
	    	if ( Database::connection () -> query ( "DELETE FROM drivefiles WHERE physicalname='$physicalname';" ) ) {
	    	    $this -> page [ "text" ] .= $successfuldelete;
	    	} else {
	    	    $this -> page [ "text" ] .= $unsuccessfuldelete;
	    	}
	    } else {
	    	$this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nepodařilo se smazat fyzický soubor" ) .' '. $physicalname .'!</strong></p>';
	    }
	} elseif ( !empty  ( $_GET [ "directory" ] ) ) {
	    if ( $_GET [ $type ] == "styles" || $_GET [ $type ] == "xhtml" || $_GET [ $type ] == "images" ) {
	    	$this -> page [ "text" ] .= "<p><strong class=\"warning\">". _( "Nemůžete mazat tyto složky!" ) ."</strong></p>";
	    	return;
	    }
	    $files_inside = Database::connection () -> getResult ( "SELECT COUNT(*) FROM drivefiles WHERE parent='$physicalname';" );
	    if ( $files_inside > 0 ) {
	    	$this -> page [ "text" ] = '<p><strong class="warning">'. _( "Složka není prázdná, nelze ji proto smazat" ) .'!</strong></p>';
	    	return;
	    }

	    if ( rmdir ( $fold_from . $physicalname ) ) {
	    	if ( Database::connection () -> query ( "DELETE FROM drivefiles WHERE physicalname='$physicalname';" ) ) {
	    	    $this -> page [ "text" ] .= $successfuldelete;
	    	} else {
	    	    $this -> page [ "text" ] .= $unsuccessfuldelete;
	    	}
	    } else {
	    	$this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nepodařilo se smazat fyzickou složku" ) .' '. $physicalname .'!</strong></p>';
	    }
	}

	$this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    } // end deleteIt

    private function reallyDelete ()
    {
    	$this -> page [ "title" ] = _( "Smazat" );
    	$type = ( isset ( $_GET [ "directory" ] ) ) ? "directory" : "file";
	if ( $type == "directory" && ( $_GET [ $type ] == "styles" || $_GET [ $type ] == "xhtml" || $_GET [ $type ] == "images" ) ) {
	    $this -> page [ "text" ] .= "<p><strong class=\"warning\">". _( "Nemůžete mazat tyto složky!" ) ."</strong></p>";
	    return;
	}
    	$this -> page [ "text" ] .= "<p>". _( "Opravdu si přejete tento objekt vymazat?" ) ."</p>";
    	if ( Database::connection () -> getResult ( "SELECT group FROM drivefiles WHERE physicalname='". addslashes ( $_GET [ $type ] ) ."';" ) == "administrators" ) {
    	    $this -> page [ "text" ] .= "<p><strong class=\"warning\">". _( "Buďte opatrní, mažete soubor patřící skupině administrátorů" ) ."!</strong></p>";
    	}
    	$this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="ajaxDialogue(\''. Tools::getPage () .'.xml?action=delete2&#038;'. $type .'='. $_GET [ $type ] .'\');directoryContent.destroyArticleActions();" value="'. _( "ano" ) .'" /> <input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "ne" ) .'" />';
    } // end reallyDelete

    private function moveFile ( $target_dir, $file )
    {
    	if ( $target_dir == "root" ) {
	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nelze provádět přesun do kořenové složky." ) .'</strong></p>';
	    return;
	}
	if ( $file == "styles" || $file == "xhtml" || $file == "images" ) {
	    $this -> page [ "text" ] .= "<p><strong class=\"warning\">". _( "Nemůžete přesouvat tyto složky!" ) ."</strong></p>";
	    return;
	}
	// access checking ///////////////////////////////////////////////////////////
	$access_dir = Database::connection () -> fetch_assoc ( "SELECT author, groupid, access FROM drivefiles WHERE parent='$file';" );
	if ( !SecurityTools::check_write ( $access_dir [ "access" ], $access_dir [ "author" ], $access_dir [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
	    return;
	}
	$access_object = Database::connection () -> fetch_assoc ( "SELECT author, groupid, access FROM drivefiles WHERE physicalname='$file';" );
	if ( !SecurityTools::check_write ( $access_object [ "access" ], $access_object [ "author" ], $access_object [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povoleno přesunování tohoto souboru" ) .'!</strong></p>';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

    	$fold_from = "";
	$parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$file ';" );
    	while ( $parent != "root" && $parent != "" ) {
    	    $fold_from = $parent ."/". $fold_from;
    	    $parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$parent';" );
    	}

    	$fold_to = $target_dir;
	if ( $fold_to != "root" && $fold_to != "" ) {
	    $parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$target_dir';" );
    	    while ( $parent != "root" && $parent != "" ) {
    	    	$fold_to = $parent ."/". $fold_to;
    	    	$parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$parent';" );
    	    }
   	}

	if ( rename ( $fold_from . $file,  $fold_to ."/". $file ) ) {
	    if ( Database::connection () -> query ( "UPDATE drivefiles SET parent='$target_dir' WHERE physicalname='$file';" ) ) {
	    	$this -> page [ "text" ] .= "<p>". _( "Přesun proběhl úspěšně." ) ."</p>";
	    } else {
	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Přesun se nezdařil." ) ."</strong>"."</p>";
	    }
	} else {
	    $this -> page [ "text" ] .= '<p><strong class="warning">'.$fold_from . $file." * ".$fold_to ."/". $file. _( "Nepodařilo se přesunout fyzický soubor." ) ."</strong>"."</p>";
	}
    }

    private function moveIt ()
    {
    	$this -> page [ "title" ] = _( "Přesun" );

	$successfulmove = "<p>". _( "Přesun proběhl úspěšně." ) ."</p>";
	$unsuccessfulmove = '<p><strong class="warning">'. _( "Přesun se nezdařil." ) ."</strong>"."</p>";

	if ( $_GET [ "leftdir" ] == $_GET [ "rightdir" ] ) {
	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nelze přesouvat ve stejných složkách." ) .'</strong></p>';
	    return;
	}

	// moves file ////////////////////////////////////////////////////////////////
	if ( ( isset ( $_GET [ "file" ] ) || isset ( $_GET [ "directory" ] ) ) && isset ( $_GET [ "leftdir" ], $_GET [ "rightdir" ] ) ) {
	    $what = ( isset ( $_GET [ "file" ] ) ) ? htmlspecialchars ( $_GET [ "file" ] ) : htmlspecialchars ( $_GET [ "directory" ] );
	    if ( $file = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$what';" ) ) {
	    	// move article from left directory to right directory ///////////////////////
	    	if ( $file == $_GET [ "leftdir" ] ) {
		    $this -> moveFile ( $_GET [ "rightdir" ], $what );
	    	//////////////////////////////////////////////////////////////////////////////
	    	// move article from right directory to left directory ///////////////////////
	    	} elseif ( $file == $_GET [ "rightdir" ] ) {
		    $this -> moveFile ( $_GET [ "leftdir" ], $what );
	    	//////////////////////////////////////////////////////////////////////////////
	    	} else {
	    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se určit složky pro přesun." ) .'</strong></p>';
	    	}
	    } else {
	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se načíst údaje z databáze." ) .'</strong></p>';
	    }
	//////////////////////////////////////////////////////////////////////////////
	}
    	
    	$this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    } // end moveIt

    private function copyFile ( $file, $directory )
    {

	$directory = htmlspecialchars ( $directory );

	// access checking ///////////////////////////////////////////////////////////
	$row = Database::connection () -> fetch_assoc ( "SELECT author, groupid, access FROM drivefiles WHERE physicalname='$directory';" );
    	$parent_dir = ( is_array ( $row ) ) ? $row : array ( "author" => 1, "groupid" => 1, "access" => "ww0", "physicalname" => $file );

	if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
	    return;
	}
	if ( !SecurityTools::check_write ( $file [ "access" ], $file [ "author" ], $file [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povoleno kopírování tohoto souboru" ) .'!</strong></p>';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

    	$copy = _( "kopie" );

    	if ( $text = $this -> check_duplicity ( $copy ."-". $file [ "physicalname" ], $file [ "parent" ] ) ) { // there is some duplicity in database
    	    $this -> page [ "text" ] .= $text;
    	    return;
    	}

	$fold_from = "";
	$parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='". $file [ "physicalname" ] ."';" );
    	while ( $parent != "root" && $parent != "" ) {
    	    $fold_from = $parent ."/". $fold_from;
    	    $parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$parent';" );
    	}
    	$fold_to = $directory;
	if ( $fold_to != "root" && $fold_to != "" ) {
	    $parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$directory';" );
    	    while ( $parent != "root" && $parent != "" ) {
    	    	$fold_to = $parent ."/". $fold_to;
    	    	$parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$parent';" );
    	    }
   	}

    	if ( copy ( $fold_from . $file [ "physicalname" ],  $fold_to ."/". $copy ."-". $file [ "physicalname" ] ) &&
    	     file_exists ( $fold_to ."/". $copy ."-". $file [ "physicalname" ] ) ) {
    	    if ( Database::connection () -> query ( "INSERT INTO drivefiles VALUES ( '$copy-". $file [ "physicalname" ] ."', ". User::session () -> getId () .", '". $file [ "groupid" ] ."', '". $file [ "access" ] ."', '$directory' );" ) ) {
	    	$this -> page [ "text" ] .= "<p>". $file [ "physicalname" ] ." - ". _( "Kopírování souboru proběhlo úspěšně." ) ."</p>";
	    } else {
		$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se vytvořit obsah kopie souboru" ) .' '. $file [ "physicalname" ] .'.</strong></p>';
	    }
	} else {
	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se vytvořit fyzickou kopii souboru" ) .' '. $file [ "physicalname" ] .'.</strong></p>';
	}

    } // end copyFile

    private function copyIt ()
    {
    	$this -> page [ "title" ] = _( "Kopírování" );

	$successfulcopy = "<p>". _( "Kopírování proběhlo úspěšně." ) ."</p>";
	$copy = _( "kopie" );
	
	if ( !empty  ( $_GET [ "file" ] ) && !empty ( $_GET [ "leftdir" ] ) && !empty ( $_GET [ "rightdir" ] ) ) {
	    if ( $file = Database::connection () -> fetch_assoc ( "SELECT * FROM drivefiles WHERE physicalname='". htmlspecialchars ( $_GET [ "file" ] ) ."';" ) ) { // gets file from database
	    	// copy file from left window /////////////////////////////////////////////////
	    	if ( $file [ "parent" ] == $_GET [ "leftdir" ] ) { // it`s file from left window
	    	    if ( $_GET [ "rightdir" ] == "root" ) {
	    	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nelze provádět kopírování do kořenové složky." ) .'</strong></p>';
	    	    	return;
	    	    }
	    	    $this -> copyFile ( $file, $_GET [ "rightdir" ] );
	    	//////////////////////////////////////////////////////////////////////////////
	    	// copy file from right window ///////////////////////////////////////////////
	    	} elseif ( $file [ "parent" ] == $_GET [ "rightdir" ] ) { // it`s file from right window
	    	    if ( $_GET [ "leftdir" ] == "root" ) {
	    	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nelze provádět kopírování do kořenové složky." ) .'</strong></p>';
	    	    	return;
	    	    }
		    $this -> copyFile ( $file, $_GET [ "leftdir" ] );
		//////////////////////////////////////////////////////////////////////////////
	    	} else {
	    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se určit složky pro kopírování." ) .'</strong></p>';
	    	}
	    } else {
	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se načíst soubor. Pravděpodobně jde o soubor bez záznamu v databázi." ) .'</strong></p>';
	    }
	}

    	$this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    } // end copyIt

    private function uploadForm ()
    {

	$this -> page [ "title" ] = _( "Nahrát soubory na server" );

	if ( empty  ( $_GET [ "dirid" ] ) || $_GET [ "dirid" ] == "root" ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze nahrávat soubory do kořenového adresáře!" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	$parent_dir = Database::connection () -> fetch_assoc ( "SELECT physicalname, author, groupid, access FROM drivefiles WHERE physicalname='". addslashes ( $_GET [ "dirid" ] ) ."';" );

	// if folder isn`t defined in database, we don`t allow to write in
	if ( !is_array ( $parent_dir ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	// access checking ///////////////////////////////////////////////////////////
	if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

	$this -> page [ "text" ] = '
	<form action="'. Localization::session () -> getFile ( "cor-drive-contents") .'" method="post" enctype="multipart/form-data">
	    <fieldset>
		<label for="file">'. _( 'Soubor' ) .': </label><input type="file" name="file" /><br />
	    	<label for="access">'. _( 'Přístup' ) .': </label>
		<select name="access" onchange="changeAccessInformation(this.value,\'accessInformation\');";>
	    	    <option value="wwr">'. _( "Veřejný" ) .'</option>
	    	    <option value="ww0">'. _( "Skupinový" ) .'</option>
	    	    <option value="wrr" selected="selected">'. _( "Chráněný" ) .'</option>
	    	    <option value="wr0">'. _( "Soukromý" ) .'</option>
	    	    <option value="w00">'. _( "Zabezpečený" ) .'</option>
	    	</select><br />
	    	<span id="accessInformation" class="floatLeft"><strong>'. _( "Autor může zapisovat, skupina může zapisovat a ostatní nemohou nic." ) .'</strong></span><br />
	    	<label for="usergroup">'. _( 'Skupina' ) .': </label>
	    	<select name="usergroup">';
	if ( User::session () -> getPrimaryGroup () >= 3 ) {
	     $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups WHERE id IN (SELECT groupid FROM membersofgroups WHERE userid=". User::session () -> getId () .");" );
	     foreach ( $usergroups as $group ) {
	   	$this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'"'. ( ( $article [ "groupid" ] == $group [ "id" ] ) ? " selected=\"selected\"" : "" ) .'>'. $group [ "usergroup" ] .'</option>';
	     }
	     if ( User::session () -> getPrimaryGroup () ) $this -> page [ "text" ] .= '<option value="4">'. _( "Uživatelé" ) .'</option>';
	} else {
	     $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups;" );
	     if ( User::session () -> getPrimaryGroup () == 2 ) unset ( $usergroups [ 0 ] );
	     foreach ( $usergroups as $group ) {
	   	$this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'">'. $group [ "usergroup" ] .'</option>';
	     }
	}
	$this -> page [ "text" ] .= '</select><br />
	    	<input type="hidden" name="parent" value="'. htmlspecialchars ( $_GET [ "dirid" ] ) .'" />
	    	'. _( "Rodičovská složka" ) . ': <strong>'. $parent_dir [ "physicalname" ] .'</strong><br />
	    	<input type="submit" value="'. _( "Nahrát na server" ) .'" />
	    </fieldset>
	</form>';
    	
    }

    private function showImage ()
    {
    	$this -> page [ "title" ] = _( "Obrázek" );
    	$src = htmlspecialchars ( $_GET [ "src" ] );
    	$physicalname = substr ( strrchr ( $src, "/" ), 1 );

    	if ( !file_exists ( $src ) ) {
    	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Požadovaný soubor se na disku nenachází" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	$file = Database::connection () -> fetch_assoc ( "SELECT * FROM drivefiles WHERE physicalname='$physicalname';" );
    	$file = ( is_array ( $file ) ) ? $file : array ( "author" => 1, "groupid" => 1, "access" => "ww0", "physicalname" => $physicalname );

    	$this -> page [ "text" ] .= '<img src="'. $src .'" alt="image '. $src .'" />';
    	$this -> page [ "text" ] .= '<dir class="floatRight">
 	<a href="#" class="cor-button-small cor-articleEdit" onclick="ajaxDialogue(\''. Tools::getPage () .'.xml?action=editfile&#038;physicalname='. $physicalname .'\');return false;"><span>'. _( 'editovat' ) .'</span></a>
	</dir>';
    	$this -> page [ "text" ] .= '<ul class="floatLeft">
    	<li><strong>'. _( "Cesta" ) .':</strong> '. $src .'</li>
    	<li><strong>'. _( 'Autor' ) .':</strong> '. Database::connection () -> getResult ( "SELECT nick FROM users WHERE id=". $file [ "author" ] .";" ) .'</li>
    	<li><strong>'. _( 'Skupina' ) .':</strong> '. Database::connection () -> getResult ( "SELECT usergroup FROM usergroups WHERE id=". $file [ "groupid" ] .";" ) .'</li>
    	<li><strong>'. _( "Přístupová práva" ) .':</strong> '. $file [ "access" ] .'</li></ul>';

	$this -> page [ "text" ] .= '<ul class="floatLeft">
	<li><strong>'. _( "Velikost" ) .':</strong> <span title="'. filesize ( $src ) .' B">'. (int) ( filesize ( $src ) / 1024 ) .' kB</span></li>
	<li><strong>'. _( "Poslední modifikace" ) .':</strong><br />'. date ( "j.n.Y H:i:s", filemtime ( $src ) ) .'</li>
	<li><strong>'. _( "Poslední přístup" ) .':</strong><br />'. date ( "j.n.Y H:i:s", fileatime ( $src ) ) .'</li>
	</ul>';

    	$this -> page [ "text" ] .= '<hr class="cleaner" /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    	
    }

    private function createFolder ()
    {
    	$this -> page [ "title" ] = _( "Nová složka" );

	if ( empty  ( $_POST [ "parent" ] ) || $_POST [ "parent" ] == "root" ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze vytvářet nové složky v kořenovém adresáři!" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	$parent_dir = Database::connection () -> fetch_assoc ( "SELECT physicalname, author, groupid, access FROM drivefiles WHERE physicalname='". addslashes ( $_POST [ "parent" ] ) ."';" );

	// if folder isn`t defined in database, we don`t allow to write in
	if ( !is_array ( $parent_dir ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	// access checking ///////////////////////////////////////////////////////////
	if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

	$physicalname = htmlspecialchars ( $_POST [ "title" ] );
	$access = htmlspecialchars ( $_POST [ "access" ] );
	$group = (int) $_POST [ "usergroup" ];
	$fileparent = htmlspecialchars ( $_POST [ "parent" ] );

	if ( $physicalname == "root" ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Soubor se nemůže jmenovat root!" ) .'!</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	if ( $text = $this -> check_duplicity ( $physicalname ) ) { // there is some duplicity in database
    	    $this -> page [ "text" ] .= $text;
    	    return;
    	}

	$path = htmlspecialchars ( $_POST [ "parent" ] ) ."/";
	$parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='". addslashes ( $_POST [ "parent" ] ) ."';" );
	while ( $parent != "root" ) {
    	    $path = $parent. "/" .$path;
    	    $parent = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$parent';" );
    	}

	$path .= "$physicalname";
	if ( @mkdir ( $path ) ) {
	    if ( Database::connection () -> query ( "INSERT INTO drivefiles VALUES ( '$physicalname', ". User::session () -> getId () .", '$group', '$access', '$fileparent' );" ) ) {
	    	$this -> page [ "text" ] = '<p>'. $physicalname . _( " - složka úspěšně vytvořena." ) .'</p>';
	    } else {
	    	$this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nepodařilo se vytvořit záznam o složce v databázi, ta se však na disku již nachází!" ) .'</strong></p>';
	    }
	} else {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Albireo nemohlo zapsat složku na disk" ) .': '. $path .'</strong></p>';
	}
	$this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="directoryContent.reloadContent(\''. Localization::session () -> getFile ( "cor-drive-contents", false ) .'\');closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
    } // end createFolder

    private function folderEditor ()
    {

    	$this -> page [ "title" ] = _( "Nová složka" );

	if ( empty  ( $_GET [ "dirid" ] ) || $_GET [ "dirid" ] == "root" ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nelze vytvářet nové složky v kořenovém adresáři!" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	$parent_dir = Database::connection () -> fetch_assoc ( "SELECT physicalname, author, groupid, access FROM drivefiles WHERE physicalname='". addslashes ( $_GET [ "dirid" ] ) ."';" );

	// if folder isn`t defined in database, we don`t allow to write in
	if ( !is_array ( $parent_dir ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Mateřská složka se nenalézá v databázi, proto není možný zápis!" ) .'</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}

	// access checking ///////////////////////////////////////////////////////////
	if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
	    $this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( "Zavřít" ) .'" />';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////

	$this -> page [ "text" ] = '
	<form action="xml.php?page='. Tools::getPage () .'" id="FolderEditorForm" method="post" enctype="application/x-www-form-urlencoded">
	    <fieldset>
	    	<label for="title">'. _( 'Jméno' ) .': </label><input type="text" name="title" maxlength="50" /><br />
	    	<label for="access">'. _( 'Přístup' ) .': </label>
	    	<select name="access" onchange="changeAccessInformation(this.value,\'accessInformation\');";>
	    	    <option value="wwr"'. ( ( $folder [ "access" ] == "wwr" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Veřejný" ) .'</option>
	    	    <option value="ww0"'. ( ( $folder [ "access" ] == "ww0" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Skupinový" ) .'</option>
	    	    <option value="wrr"'. ( ( $folder [ "access" ] == "wrr" ) ? " selected=\"selected\"" : ( $folder [ "access" ] ? "" : " selected=\"selected\"" ) ) .'>'. _( "Chráněný" ) .'</option>
	    	    <option value="wr0"'. ( ( $folder [ "access" ] == "wr0" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Soukromý" ) .'</option>
	    	    <option value="w00"'. ( ( $folder [ "access" ] == "w00" ) ? " selected=\"selected\"" : "" ) .'>'. _( "Zabezpečený" ) .'</option>
	    	</select><br />';

	$accessInfo = "";
	switch ( $folder [ "access" ] ) {
	    case 'wwr':
	    	$accessInfo = _( "Autor může zapisovat, skupina může zapisovat a ostatní mohou číst." );
	    	break;
	    case 'ww0':
	    	$accessInfo = _( "Autor může zapisovat, skupina může zapisovat a ostatní nemohou nic." );
	    	break;
	    case 'wrr':
	    	$accessInfo = _( "Autor může zapisovat, skupina může číst a ostatní mohou také číst." );
	    	break;
	    case 'wr0':
	    	$accessInfo = _( "Autor může zapisovat, skupina může číst a ostatní nemohou nic." );
	    	break;
	    case 'w00':
	    	$accessInfo = _( "Autor může zapisovat, skupina nemůže nic a ostatní také nemohou nic." );
	    	break;
	    default:
	    	$accessInfo = _( "Autor může zapisovat, skupina může číst a ostatní mohou také číst." );
	        
	}
	$this -> page [ "text" ] .= '<span id="accessInformation" class="floatLeft"><strong>'. $accessInfo .'</strong></span><br />
	<label for="usergroup">'. _( 'Skupina' ) .': </label>
	    	<select name="usergroup">';
	if ( User::session () -> getPrimaryGroup () >= 3 ) {
	     $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups WHERE id IN (SELECT groupid FROM membersofgroups WHERE userid=". User::session () -> getId () .");" );
	     foreach ( $usergroups as $group ) {
	   	$this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'"'. ( ( $article [ "groupid" ] == $group [ "id" ] ) ? " selected=\"selected\"" : "" ) .'>'. $group [ "usergroup" ] .'</option>';
	     }
	     if ( User::session () -> getPrimaryGroup () ) $this -> page [ "text" ] .= '<option value="4">'. _( "Uživatelé" ) .'</option>';
	} else {
	     $usergroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups;" );
	     if ( User::session () -> getPrimaryGroup () == 2 ) unset ( $usergroups [ 0 ] );
	     foreach ( $usergroups as $group ) {
	   	$this -> page [ "text" ] .= '<option value="'. $group [ "id" ] .'">'. $group [ "usergroup" ] .'</option>';
	     }
	}
	$this -> page [ "text" ] .= '</select><br />
	    	<input type="hidden" name="parent" value="'. htmlspecialchars ( $_GET [ "dirid" ] ) .'" />
	    	'. _( "Rodičovská složka" ) . ': <strong>'. $parent_dir [ "physicalname" ] .'</strong><br />
	    	<input type="submit" value="'. _( "Vytvořit" ) .'" onclick="changeDialogueByPost(\''. Tools::getPage () .'.xml?action=createfolder\',\'FolderEditorForm\');return false;" />
	    </fieldset>
	</form>';

    } // end newFolder

    private function check_duplicity ( $to_check, $parent = "null" )
    {
    	if ( ( $parent_doubler = Database::connection () -> getResult ( "SELECT parent FROM drivefiles WHERE physicalname='$to_check';" ) ) && ( $parent == "null" || $parent != $parent_doubler ) ) {
    	    return '<p><strong class="warning">'. _( "Soubor tohoto jména již existuje ve složce" ) .' '. $parent_doubler .'.</strong></p>';
	} else {
	    return false;
	}
    } // end check_duplicity

}

$Drive = new Drive ();
$page = $Drive -> page;
?>