<?php
/* **************************************************************************** *

 * cor-extensions.php								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*
 
 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Page for Extensions.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none

 * **************************************************************************** */

class Extensions {

    public $page = array ( "text" => "" );

    public function __construct ()
    {

	if ( isset ( $_GET [ "action" ] ) && $_GET [ "action" ] = "upload" ) {
	    $this -> page [ "title" ] = _( "Nahrát rozšíření a instalovat" );
	    $this -> page [ "text" ] = '
		<form action="'. Tools::getFullPage () .'" method="post" enctype="multipart/form-data">
	    	    <fieldset>
			<label for="file">'. _( 'Soubor' ) .': </label><input type="file" name="file" /><br />
	    		<input type="submit" value="'. _( "Nahrát a instalovat na server" ) .'" />
	    	    </fieldset>
		</form>
		<p>'. _( 'Upozorňujeme, že je <strong class="warning">nebezpečné</strong> instalovat rozšíření z neověřených zdrojů (může způsobit ztrátu dat nebo kompromitaci serveru). Svá data před instalací raději zálohujte a uložte mimo server.' ) .'</p>
		<input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="'. _( 'Zavřít' ) .'" />';
	} else {
	    if ( isset ( $_FILES [ "file" ] ) ) {
    	    	$this -> uploadFile ();
    	    }
	    $this -> page [ "text" ] .= '<link rel="stylesheet" type="text/css" href="styles/cor-extensions.css" charset="UTF-8" media="screen" />
    		<div id="extensionscontrolmenu">
    	    	    <a href="#" class="cor-button-small cor-upload" onclick="ajaxDialogue(\''. Tools::getPage () .'.xml?action=upload\');return false;"><span>'. _( "Nahrát rozšíření" ) .'</span></a>
    		</div>
    		<hr class="cleaner" />';
	    $this -> page [ "text" ] .= '
	    <div class="actionbar">
	    	<img src="styles/cor-admin/extensions-icon.jpg" alt="'. _( "Ikona rozšíření" ) .'" class="objectLeft" />
	    	<h2>'. _( "Instalovaná rozšíření" ) .'</h2>
	    	<p>'. _( "Rozšíření přidávají různé podrogramy do Albirea poskytující na příklad fotogalerii, ankety nebo vyhledávání. Buďtě však opatrní na zdroje nových rozšíření, aby nedošlo ke kompromitaci Vašeho serveru nebo jeho poškození." ) .'</p>
	    	<hr class="cleaner" /></div>';
	    $extarray = Database::connection() -> fetchall_assoc ( "SELECT * FROM extensions;" );
	    foreach ( $extarray as $links ) {
		$this -> page [ "text" ] .= '<a href="'. $links [ "file" ] .'">'. $links [ "file" ] .'</a> - '. $links [ "description" ] .'<br />';
	    }
	    $this -> page [ "text" ] .= '</div>';

	}

    } // end __construct

    private function uploadFile () {

    	$files = $_FILES [ "file" ];
    	$physicalname = htmlspecialchars ( $files [ "name" ] );
    	$type = substr ( strrchr ( $physicalname, "." ), 1 ); // find type of file
    	if ( $type != "zip" ) {
    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Soubor s rozšířením nemá formát ZIP archivu!" ) .'</strong></p>';
    	    return;
    	}

    	if ( !@move_uploaded_file ( $files [ "tmp_name" ],  "temporary/". $physicalname ) ) {
    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Soubor nešlo přesunout do souborové struktury Albirea!" ) .'</strong></p>';
    	    return;
    	}

    	$PackageManager = new PackageManager ();
    	$issue = $PackageManager -> installPackage ( $physicalname );

    	if ( $issue [ "errors" ] > 0 ) {
    	    if ( $issue [ "installed" ] > 0 ) {
    	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Podařilo se nainstalovat jen některé soubory rozšíření. Mohlo dojít k poškození integrity systému!" ) .'</strong></p>';
    	    	$this -> page [ "text" ] .= $issue [ "error messages" ];
    	    	return;
    	    } else {
    	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Instalace rozšíření selhala při přesunu souborů v rámci struktury Albirea." ) .'</strong></p>';
    	    	return;
    	    }
    	} else {
    	    $this -> page [ "text" ] .= '<p><strong class="success">'. _( "Počet instalovaných souborů:" ) .' '. $issue [ "installed" ] .'</strong></p>';
    	    $this -> page [ "text" ] .= '<p><a href="#" onclick="$(\'#okmessages\').show(\'slow\');$(this).hide(\'fast\');return false;" title="'. _( "Ukázat seznam instalovaných souborů" ) .'">'. _( "Ukázat seznam instalovaných souborů" ) .'</a></p>';
    	    $this -> page [ "text" ] .= '<span id="okmessages" class="undisplayed"><div class="actionbar">';
    	    $this -> page [ "text" ] .= $issue [ "ok messages" ];
    	    $this -> page [ "text" ] .= '</div></span>';
    	}

    	if ( file_exists ( "temporary/mysql.sql" ) ) {
    	    if ( $mysql_result = Database::connection () -> sql_from_file ( "temporary/mysql.sql" ) ) {
		if ( $mysql_result [ "errors" ] > 0 ) {
    	    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Během provádění SQL příkazů pro MySQL databázi při instalaci rozšíření se vyskytla chyba." ) .'</strong> '. _( "Počet chyb" ) .' <strong>'. $mysql_result [ "errors" ] .'</strong></p>';
    	    	} else {
    	    	    $this -> page [ "text" ] .= '<p><strong class="success">'. _( "Albireo úspěšně provedlo SQL dotazy na MySQL požadované rozšířením." ) .'</strong></p>';
    	   	}
    	    } else {
    	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Neočekávaná chyba při načítání SQL příkazů pro MySQL databázi při instalaci rozšíření." ) .'</strong></p>';
    	    	return;
    	    }
    	}

    	if ( file_exists ( "temporary/sqlite.sql" ) ) {
    	    $Settings = new Settings ( $physicalname );
    	    if ( $sqlite_issue = $Settings -> SQLiteFromFile ( "temporary/sqlite.sql" ) ) {
    	    	if ( $sqlite_issue [ "errors" ] > 0 ) {
    	    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Během provádění SQL příkazů pro SQLite databázi při instalaci rozšíření se vyskytla chyba." ) .'</strong> '. _( "Počet chyb" ) .' <strong>'. $sqlite_issue [ "errors" ] .'</strong></p>';
    	    	} else {
    	    	    $this -> page [ "text" ] .= '<p><strong class="success">'. _( "Albireo úspěšně provedlo SQL dotazy na SQlite požadované rozšířením." ) .'</strong></p>';
    	   	}
    	    } else {
    	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Neočekávaná chyba při načítání SQL příkazů pro SQLite databázi při instalaci rozšíření." ) .'</strong></p>';
    	    	return;
    	    }
    	}

    	$this -> page [ "text" ] .= '<p><strong class="success">'. _( "Rozšíření bylo nainstalováno." ) .'</strong></p>';
    	return;

    } // uploadFile

}

$Extensions = new Extensions ();
$page = $Extensions -> page;
?>