<?php
/* **************************************************************************** *

 * cor-mysql-backups.php							*
 * @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*

 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 This class is aimed to help administrators to backup or restore MySQL data.

 Properties:
    none

 Public Methods:
    none

 * **************************************************************************** */

class corMySQLBackups {

    public $page = array ( "text" => "" );

    public function __construct ()
    {
    	if ( isset ( $_FILES [ "sqlfile" ] ) || isset ( $_GET [ "sqlfile" ] )  ) {
    	    $file = isset ( $_FILES [ "sqlfile" ] ) ? $_FILES [ "sqlfile" ] [ "tmp_name" ] : "backups/". $_GET [ "sqlfile" ];
    	    if ( isset ( $_GET [ "sqlfile" ] ) && $_GET [ "sqlfile" ] != "" ) {
    	    	if ( substr ( $file, 1 ) == "." ||
    	    	     substr ( urldecode ( $file ), 1 ) == "." ||
    	    	     substr ( strrchr ( $file, "." ), 1 ) != "sql" ) {
    	    		Error::ticket () -> notice ( 'cor00031', 'in ' .__FILE__. ' on line ' .__LINE__, addslashes ( "$file" ) ); // possible unauthorized try to get system file
    	    	}
    	    	if ( !file_exists ( $file ) ) {
    	    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Požadovaný soubor se ve složce záloh nenachází." ) .'</strong></p>';
    	    	    return;
    	    	}
    	    }
    	    if ( !$mysql_result = Database::connection () -> sql_from_file ( $file ) ) {
    		$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Během zpracování souboru SQL se vyskytl nečekaný problém." ) .'</strong></p>';
    		return;
    	    }
    	    if ( $mysql_result [ "errors" ] > 0 ) {
    		$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Během provádení SQL dotazů se vyskytl problém" ) .'</strong></p>
    		<p><strong>'. _( "Počet chybových dotazů:" ) .'</strong> '. $mysql_result [ "errors" ] .'</p>';
    	    }
    	    if ( $mysql_result [ "ok" ] > 0 ) {
    		$this -> page [ "text" ] .= '<p><strong class="success">'. _( "Počet úspěšně vykonaných dotazů:" ) .'</strong> '. $mysql_result [ "ok" ] .'</p>';
    	    }
    	}
    	if ( isset ( $_GET [ "action" ] ) && $_GET [ "action" ] == "create" ) {
    	    $file = gmdate ( "Y-m-d-H-i-s" ) .".sql";
    	    if ( !$backup = Database::connection () -> backup_database () ) {
    		$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Během vytváření zálohy MySQL se vyskytl nečekaný problém." ) .'</strong></p>';
    		return;
    	    }
    	    
    	    $backup =
"-- ---------------------------------------------------------------------------- --

-- $file.sql
-- This is a file of backup created by user ". User::session () -> getNick () ." using core of Albireo.
-- Date (GMT,UTC): ". gmdate ( "H:i:s m.d.Y" ) ."
-- Unix time: ". time () ."

-- ---------------------------------------------------------------------------- --\n\n". $backup;

    	    if ( @file_put_contents ( "backups/". $file, $backup ) ) {
    	    	if ( Database::connection () -> query ( "INSERT INTO downloadable VALUES ('backups/$file', ". User::session () -> getId () .", 1, 'ww0');" ) ) {
    	    	    $this -> page [ "text" ] .= '<p><strong class="success">'. _( "Záloha MySQL byla úspěšně vytvořena:" ) .'</strong> '. $file .'</p>';
    	    	} else {
    	    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Zálohu se podařilo úspěšně uložit na server, avšak nepodařilo se vytvořit o ní záznam v databázi jako o stahovatelné." ) .'</strong></p>';
    	    	}
    	    } else {
    	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Během ukládání souboru zálohy MySQL se vyskytl nečekaný problém." ) .'</strong></p>';
    	    }
    	}
    	if ( isset ( $_GET [ "action" ] ) && $_GET [ "action" ] == "delete" ) {
    	    $file = $_GET [ "file" ];
    	    if ( $file == "" ) $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Pomocí URL nebyl zadán soubor ke smazání." ) .'</strong></p>';
    	    if ( substr ( $file, 1 ) == "." ||
    	    	 substr ( urldecode ( $file ), 1 ) == "." ||
    	    	 substr ( strrchr ( $file, "." ), 1 ) != "sql" ) {
    	    	Error::ticket () -> notice ( 'cor00030', 'in ' .__FILE__. ' on line ' .__LINE__, addslashes ( "$file" ) ); // possible attemp at a system file erasing
    	    }
    	    if ( file_exists ( "backups/". $file ) ) {
    	    	if ( @unlink ( "backups/". $file ) ) {
    	    	    $this -> page [ "text" ] .= '<p><strong class="success">'. _( "Soubor byl úspěšně smazán." ) .'</strong></p>';
    	    	} else {
    	    	    $this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se smazat požadovaný soubor." ) .'</strong></p>';
    	    	}
    	    } else {
    	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Požadovaný soubor se ve složce záloh nenachází." ) .'</strong></p>';
    	    }
    	}
	$this -> showOverview ();
    } // end __construct

    private function showOverview ()
    {
    	$this -> page [ "text" ] .= '<div class="actionbar">
    	    <hr /> 
    	    <img src="styles/cor-admin/db_add.jpg" alt="'. _( "Vytvořit zálohu" ) .'" class="objectLeft" />
    	    <p>'. _( "Vytvoří kompletní zálohu MySQL databáze používané Albireem a uloží ji do souboru." ) .'</p>
    	    <p><a href="'. Tools::getFullPage () .'?action=create" title="'. _( "Vytvořit zálohu MySQL" ) .'" onclick="confirmDialogue(\''. _( "Vytvořit zálohu MySQL" ) .'\',\''. _( "Vytvořit novou zálohu MySQL?" ) .'\',\''. Tools::getFullPage () .'?action=create\');return false;">'. _( "Vytvořit zálohu MySQL" ) .'</a></p>
    	    <hr class="cleaner" /><hr />
    	    <img src="styles/cor-admin/db_upload.jpg" alt="'. _( "Nahrát zálohu" ) .'" class="objectLeft" />
    	    <p>'. _( "Nahrát dávkový soubor SQL. Albireo provede všechny příkazy obsažené v souboru. Kompatibilní s phpMyAdmin." ) .'</p>
    	    <form action="'. Tools::getFullPage () .'" method="post" enctype="multipart/form-data">
    	    	<input type="file" name="sqlfile" /><br />
    	    	<input type="submit" value="'. _( "Nahrát SQL soubor a spustit" ) .'" class="nowidth" />
    	    </form>
    	    <hr class="cleaner" /><hr />
    	    <h2>'. _( "Staré zálohy systému" ) .'</h2>
    	    <table>';

    	$folder = opendir ( "backups" );
    	$table_rows = "";
    	$files = array ();
    	while ( $backup_file = readdir ( $folder ) ) {
    	    $files [] = $backup_file;
    	}
    	closedir ( $folder );
    	sort ( $files );
    	foreach ( $files as $file ) {
    	    if ( is_file ( "backups/" . $file ) ) {
    	     	$table_rows = '<tr><td>'. $file .'</td>
    	     	<td><a href="'. Tools::getFullPage () .'?sqlfile='. $file .'" title="'. _( "použít" ) .' '. $file .'" onclick="confirmDialogue(\''. _( "použít" ) .' '. $file .'\',\''. _( "Opravdu chcete použít tuto zálohu?" ) .' '. $file .'\',\''. Tools::getFullPage () .'?sqlfile='. $file .'\');return false;">'. _( "použít" ) .'</a></td>
    	     	<td><a href="'. Localization::session () -> getFile ( "cor-download" ) .'?file=backups/'. $file .'" title="'. _( "stáhnout" ) .' '. $file .'">'. _( "stáhnout" ) .'</a></td>
    	     	<td><a href="'. Tools::getFullPage () .'?action=delete&amp;file='. $file .'" title="'. _( "stáhnout" ) .' '. $file .'" onclick="confirmDialogue(\''. _( "smazat" ) .' '. $file .'\',\''. _( "Opravdu si přejete tuto zálohu smazat?" ) .' '. $file .'\',\''. Tools::getFullPage () .'?action=delete&amp;file='. $file .'\');return false;">'. _( "smazat" ) .'</a></td></tr>'.
    	     	$table_rows;
    	    }
    	}
    	$this -> page [ "text" ] .= $table_rows;

    	$this -> page [ "text" ] .= '</table>
    	</div>';
    } // end showOverview

}

$corMySQLBackups = new corMySQLBackups ();
$page = $corMySQLBackups -> page;
?>