<?php
/* **************************************************************************** *

 * cor-mysql-settings.php							*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 Page with inteface for cuminicating with MySQL database.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class MySQLSettings {

    public $page = array ( "text" => "" );

    public function __construct ()
    {
    	$this -> page [ "text" ] = '<script type="text/javascript" src="scripts/cor-form-default-text.js"></script>';
    	if ( isset ( $_POST [ "user" ], $_POST [ "pass" ], $_POST [ "dbhost" ], $_POST [ "dbname" ] ) ) {
     	    if ( $settings = self::update_mysql_settings () ) {
     	   	$this -> page [ "text" ] .= $settings;
     	    } else {
     	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Při nastavování MySQL došlo k chybě." ) .'</strong></p>';
     	    }
    	}
    	$this -> page [ "text" ] .= self::showDatabaseSettingsForm ();
    } // end __construct

    public static function showDatabaseSettingsForm ()
    {
    	
	$user = ( $setting = Tools::baseSettings () -> getSetting ( "user" ) ) ? $setting : "user";
	$pass = ( $setting = Tools::baseSettings () -> getSetting ( "pass" ) ) ? $setting : "pass";
	$dbhost = ( $setting = Tools::baseSettings () -> getSetting ( "dbhost" ) ) ? $setting : "dbhost";
	$dbname = ( $setting = Tools::baseSettings () -> getSetting ( "dbname" ) ) ? $setting : "dbname";
	
	return '<span id="corDatabaseResult"></span>
	    <form action="'. Tools::getFullPage () .'" id="DatabaseConectionForm" method="post" enctype="application/x-www-form-urlencoded">
     	    	<fieldset>
     	    	    <legend>'. _( "Nastavení databáze MySQL" ) .'</legend>
     	    	    <img src="styles/cor-admin/lock.jpg" alt="lock image" class="floatLeft" />
     	    	    <div class="cor-greatIconLeft">
     	    	    <label for="user">'. _( "Uživatel" ) .': </label>
     	    	    <input type="text" size="15" id="user" name="user" maxlength="50" value="'. $user .'"
     	    	    onfocus="onFocusFormDefaultText(\''. $user .'\',this);"
     	    	    onblur="onLostFocusFormDefaultText(\''. $user .'\',this);" /><br />
     	    	    
     	    	    <label for="user">'. _( "Heslo" ) .': </label>
     	    	    <input type="password" size="15" id="pass" name="pass" maxlength="50" value="'. $pass .'"
     	    	    onfocus="onFocusFormDefaultText(\''. $pass .'\',this);"
     	    	    onblur="onLostFocusFormDefaultText(\''. $pass .'\',this);" /><br />
     	    	    
     	    	    <label for="user">'. _( "Host" ) .': </label>
     	    	    <input type="text" size="15" id="dbhost" name="dbhost" maxlength="50" value="'. $dbhost .'"
     	    	    onfocus="onFocusFormDefaultText(\''. $dbhost .'\',this);"
     	    	    onblur="onLostFocusFormDefaultText(\''. $dbhost .'\',this);" /><br />

     	    	    <label for="user">'. _( "Název databáze" ) .': </label>
     	    	    <input type="text" size="15" id="dbname" name="dbname" maxlength="50" value="'. $dbname .'"
     	    	    onfocus="onFocusFormDefaultText(\''. $dbname .'\',this);"
     	    	    onblur="onLostFocusFormDefaultText(\''. $dbname .'\',this);" /><br />
     	    	    
     	    	    <input type="submit" value="'. _( "Uložit nastavení" ) .'" onclick="changeIdByPost(\''. Tools::getFullPage () .'.xml?action=database\',\'DatabaseConectionForm\',\'corDatabaseResult\');return false;" />
     	    	    </div>
             	</fieldset>
     	    </form>';
    } // end showDatabaseSettingsForm

    public static function update_mysql_settings ()
    {
    
    	if ( !isset ( $_POST [ "user" ], $_POST [ "pass" ], $_POST [ "dbhost" ], $_POST [ "dbname" ] ) ) {
     	    return false;
    	}
    	
    	$dbhost = addslashes ( $_POST [ "dbhost" ] );
    	$user = addslashes ( $_POST [ "user" ] );
    	$pass = addslashes ( $_POST [ "pass" ] );
    	$dbname = addslashes ( $_POST [ "dbname" ] );

    	if ( !Database::connection () -> connect_to ( $dbhost, $user, $pass, $dbname ) ) {
    	    return '<p><strong class="warning">'. _( "K MySQL databázi se nepodařilo podle nově zadaných údajů připojit." ) .'</strong></p>';
    	}
    	
    	if ( !Tools::baseSettings () -> updateSetting ( "dbhost", $dbhost ) ||
    	     !Tools::baseSettings () -> updateSetting ( "user", $user ) ||
    	     !Tools::baseSettings () -> updateSetting ( "pass", $pass ) ||
    	     !Tools::baseSettings () -> updateSetting ( "dbname", $dbname ) ) {
    	    return false;
    	}
    	
    	return "<p><strong class=\"success\">Připojení k databázi MySQL bylo úspěšně nastaveno.</strong></p>";
    } // end update_mysql_settings

}

$MySQLSettings = new MySQLSettings ();
$page = $MySQLSettings -> page;
?>