<?php
/* **************************************************************************** *

 * cor-overview.php								*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 Home page for administration of Albireo showing statistics and similar.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class Overview {

    public $page = array ( "text" => "" );

    public function __construct ()
    {
    	$this -> checkBrowser ();
	$this -> default_statistics ();
    } // end __construct

    private function default_statistics ()
    {
    
    	$logins = Database::connection () -> fetchall_assoc ( "SELECT * FROM logins WHERE id=". User::session () -> getId () ." ORDER BY time DESC LIMIT 1, 5;" );
    	
	$this -> page [ "title" ] = _( "Vítejte zpět, " ). User::session () -> getFullName ();
	
    	if ( is_array ( $logins ) ) {
    	    $this -> page [ "text" ] .=
    		'<h2 style="text-align:center;">'. _( "Albireo Beta" ) .'</h2>
    		<p>'. _( "Albireo Beta je určeno pro testování. Autorský tým nenese žádnou odpovědnost za selhání při ostrém nasazení. A přestože se budeme snažit o plnou kompatibilitu s ostrou verzí, ani to nemůžeme zaručit. Pro bližší informace navštivte:" ) .' <a href="http://www.albireo.name/" title="Albireo.name">www.albireo.name</a>.<br />
    		<a href="http://www.albireo.name/diskusni-fora" title="Diskusní fóra Albirea">Diskusní fóra Albirea</a><br />
    		<a href="mailto:albireo@albireo.name" title="E-mail Albirea">E-mail vývojářů - albireo@albireo.name</a></p>
    		<table class="table">
    		<caption>Posledních 5 přihlášení</caption>
    		<tr><th>Datum</th><th>IP</th></tr>';
    	    foreach ( $logins as $loginy ) {
    	    	$this -> page [ "text" ] .= '<tr><td>'.intval ( substr ( $loginy [ "time" ], 8, 2 ) ) .". "
    	    	. intval ( substr ( $loginy [ "time" ], 5, 2 ) ).
    	    	". ". substr ( $loginy [ "time" ], 0, 4 ) ." - ". substr ( $loginy [ "time" ], 11, 5 ) .'</td><td>'
    	    	. $loginy [ "ip" ] .'</td></tr>';
    	     }
    	     $this -> page [ "text" ] .= '</table>';
    	}
    	
    } // end default_statistics

    private function checkBrowser ()
    {
    	if ( !eregi ( "firefox", $_SERVER [ "HTTP_USER_AGENT" ] ) && !eregi ( "opera", $_SERVER [ "HTTP_USER_AGENT" ] ) ) {
    	    $this -> page [ "text" ] .= '<div id="firefox" class="border center"><img src="styles/cor-admin/firefox.jpg" class="floatLeft" alt="firefox" /><p>'.
    	    _( "Pro lepší kompatibilitu se systémem Albireo používejte moderní <strong>prohlížeč Firefox</strong>." )
    	    .'</p><p>'.
	    _( "Firefox je tak jako Albireo šířen <strong>pod svobodnou licencí</strong> a sami brzo zjistíte, že Vám dává při pohybu na internetu mnohem <strong>větší možnosti</strong>." )
    	    .'</p>'. _( '<a href="http://www.czilla.cz/produkty/firefox/stahnout.html" title="Stáhněte si Firefox"><img src="styles/cor-admin/firefox2.gif" alt="zkuste firefox" /></a>' ) .'<hr class="cleaner" /></div>';
    	}
    } // end checkBrowser

}

$Overview = new Overview ();
$page = $Overview -> page;
?>