<?php
/* **************************************************************************** *

 * cor-set-user.php								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*
 
 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Script for managing user settings

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class SetUser {

    public $page = array ();

    public function __construct ()
    {

	if ( isset ( $_POST [ "fullname" ], $_POST [ "oldpass" ], $_POST [ "pass" ], $_POST [ "pass2" ], $_POST [ "language" ] )  ) {
    	    $this -> page [ "text" ] .= $this -> updateUser ();
    	} else {
    	    $this -> page [ "text" ] .= $this -> userDatabaseForm ();
    	}

    } // end __construct

    private function updateUser ()
    {
    	if ( empty ( $_POST [ "oldpass" ] ) ) {
    	    $fullname = htmlspecialchars ( $_POST [ "fullname" ] );
    	    $language = htmlspecialchars ( $_POST [ "language" ] );
    	    if ( Database::connection () -> query ( "UPDATE users SET fullname='$fullname', language='$language' WHERE id=". User::session () -> getId () .";" ) ) {
    	    	return '<p><strong class="success">'. User::session () -> getNick () . ' - '. _( "uživatel byl úspěšně upraven") .'.</strong></p>';
    	    } else {
    	    	return '<p><strong class="warning">'. User::session () -> getNick () . ' - '. _( "nepodařilo se změnit profil uživatele" ) .'!</strong></p>';
    	    }
    	} else {
    	    $fullname = htmlspecialchars ( $_POST [ "fullname" ] );
    	    $language = htmlspecialchars ( $_POST [ "language" ] );

    	    if ( $_POST [ "pass" ] != $_POST [ "pass2" ] ) {
    	    	return '<p><strong class="warning">'. _( "Nové heslo a ověření hesla se neshodují" ) .'!</strong></p>';
    	    }

    	    if ( strlen ( $_POST [ "pass" ] ) < 6 ) {
    	    	return '<p><strong class="warning">'. _( "Délka hesla musí být minimálně 6 znaků" ) .'!</strong></p>';
    	    }

	    $oldpass = md5 ( $_POST [ "oldpass" ] );
    	    if ( Database::connection () -> getResult ( "SELECT password FROM users WHERE id=". User::session () -> getId () .";" ) != $oldpass ) {
    	    	return '<p><strong class="warning">'. _( "Staré heslo je chybné" ) .'!</strong></p>';
    	    }

    	    $password = md5 ( $_POST [ "pass" ] );
    	    if ( Database::connection () -> query ( "UPDATE users SET fullname='$fullname', language='$language', password='$password' WHERE id=". User::session () -> getId () .";" ) ) {
    	    	return '<p><strong class="success">'. User::session () -> getNick () . ' - '. _( "uživatel a jeho heslo byli úspěšně upraveni") .'.</strong></p>';
    	    } else {
    	    	return '<p><strong class="warning">'. User::session () -> getNick () . ' - '. _( "nepodařilo se změnit profil uživatelea heslo" ) .'!</strong></p>';
    	    }
    	}
    } // end updateUser

    private function userDatabaseForm ()
    {

	$form .= '<script type="text/javascript" src="scripts/cor-user-administration.js"></script>
	    <form action="'. Tools::getFullPage () .'" method="post" enctype="application/x-www-form-urlencoded">
	    	<fieldset>
     	    	    <legend>'. _( "Upravit profil" ) .'</legend>
     	    	    <img src="images/users-icons/free-icons/blue-user-big.jpg" alt="blue user icon" class="floatLeft" />
     	    	    <div class="cor-greatIconLeft">
     	    	    <label for="fullname">'. _( "Občanské jméno" ) .': </label><input type="text" name="fullname" maxlength="40" value="'. User::session () -> getFullName () .'" /><br />
     	    	    <label for="language">'. ( "Jazyk" ) .': </label><select name="language">
             	    	<option value="cs"'. ( ( User::session () -> getLanguage () == "cs" ) ? " selected=\"selected\"" : "" ) .'>čeština</option>
             	    </select><br />
             	    <label for="oldpass">'. _( "Staré heslo" ) .': </label><input type="password" size="15" name="oldpass" maxlength="25" /><br />
             	    <label for="pass">'. _( "Nové heslo" ) .': </label><input type="password" size="15" name="pass" maxlength="25" onkeyup="passwordStrength(this.value,\'passwordStrength\');" /><br />
             	    <span id="passwordStrength" class="floatLeft">'. _( "Zde bude zobrazeno hodnocení nového hesla" ) .'</span><br />
             	    <label for="pass2">'. _( "Ověření hesla" ) .': </label><input type="password" size="15" name="pass2" maxlength="25" /><br />
             	    <input type="submit" value="'. ( "Uložit změny" ) .'" />
             	    </div>
             	</fieldset>
	    </form>';

	$usergroups = Database::connection () -> fetchall_assoc ( "SELECT usergroup FROM usergroups WHERE id=". User::session () -> getId () .";" );
	$form .= "<p>". _( "Patříte do skupin" ) .": ";
	foreach ( $usergroups as $group ) {
	    $form .= "<strong>". $group [ "usergroup" ] ."</strong>,";
	}
	$form = substr ( $form, 0, -1 ) . "</p><p>". _( "Příslušnost do skupin mohou určovat pouze administrátoři a webmasteři." ) ."</p>";

	return $form;
    
    } // end userDatabaseForm

}

$SetUser = new SetUser ();
$page = $SetUser -> page;
?>