<?php
/* **************************************************************************** *

 * cor-statistics.php								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*
 
 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Page with statistics of web pages using Albireo.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class Statistics {

    public $page = array ();

    public function __construct ()
    {
	$this -> page [ "text" ] = '<p>' ._( 'Seznam statistik dostupných pro Albireo.' ) .'</p>';

    	$this -> page [ "text" ] .= '<div class="actionbar">
    	    <a href="'. Localization::session () -> getFile ( "cor-download-stats" ) .'"><img src="styles/cor-admin/down.jpg" class="objectLeft" alt="'. ( "Stažení" ) .'" /></a>
    	    <h2><a href="'. Localization::session () -> getFile ( "cor-download-stats" ) .'">'. _( 'Statistiky Stahování' ) .'</a></h2>
	    <p>'. _( "Poslední dvě stažení:" ) .'<br />';

	$lastdownloads = Database::connection () -> fetchall_assoc ( "SELECT * FROM downloadstats ORDER BY time DESC LIMIT 2" );
	if ( is_array ( $lastdownloads ) ) {
	    foreach ( $lastdownloads as $download ) {
	    	$this -> page [ "text" ] .= Tools::getRightDate ( $download [ "time" ], "full" ) .'<br /><strong>'. $download [ "url" ] .'</strong><br />';
	    }
	} else {
	    $this -> page [ "text" ] .= _( "Žádný soubor ještě nebyl stažen." );
	}
    	    
    	$this -> page [ "text" ] .= '</p>
    	</div><hr class="cleaner" />';

    } // end __construct

}

$Statistics = new Statistics ();
$page = $Statistics -> page;
?>