<?php
/* **************************************************************************** *

 * cor-user-control.php								*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 Page for managing users for administrators and webmasters

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class UserControl {

    public $page = array ( "text" => "" );

    public function __construct ()
    {

	if ( !empty ( $_GET [ "show" ] ) ) {
	    // this code will show list of users of requested primary group
	    // if user does not have access to view this group, it means that he tried to access it by changing URL and this action
	    // will end by security error cor00032
	    $usertype = (int) $_GET [ "show" ];
	    switch ( $usertype ) {
	    	case 1:
	    	    if ( User::session () -> getPrimaryGroup () == 1 ) $this -> showUsers ( 1 );
	    	    else Error::ticket () -> notice ( 'cor00032', 'in '. __FILE__ .' on line '. __LINE__ , Tools::getFullPage () ." ". User::session () -> getNick () );
	    	    break;
	    	case 2:
	    	    if ( User::session () -> getPrimaryGroup () <= 2 ) $this -> showUsers ( 2 );
	    	    else Error::ticket () -> notice ( 'cor00032', 'in '. __FILE__ .' on line '. __LINE__ , Tools::getFullPage () ." ". User::session () -> getNick () );
	    	    break;
	    	case 3:
	    	    if ( User::session () -> getPrimaryGroup () <= 3 ) $this -> showUsers ( 3 );
	    	    else Error::ticket () -> notice ( 'cor00032', 'in '. __FILE__ .' on line '. __LINE__ , Tools::getFullPage () ." ". User::session () -> getNick () );
	    	    break;
	    	case 4:
	    	    if ( User::session () -> getPrimaryGroup () <= 4 ) $this -> showUsers ( 4 );
	    	    else Error::ticket () -> notice ( 'cor00032', 'in '. __FILE__ .' on line '. __LINE__ , Tools::getFullPage () ." ". User::session () -> getNick () );
	    	    break;
	    	default:
	    	    $this -> showUsers ( (int) $_GET [ "show" ] );
	    }
	    return;
	} elseif ( !empty ( $_GET [ "user" ] ) ) {
	    $this -> showUser ( $_GET [ "user" ] );
	    return;
	} elseif ( !empty ( $_GET [ "showgroups" ] ) ) {
	    if ( $_GET [ "showgroups" ] == "all" ) {
	    	$this -> showgroups ();
	    	return;
	    } else {
	    	Error::ticket () -> notice ( 'cor00032', 'in '. __FILE__ .' on line '. __LINE__ , Tools::getFullPage () ." ". User::session () -> getNick () );
	    }
	}

	$this -> page [ "text" ] = '<script type="text/javascript" src="scripts/cor-user-administration.js"></script>
	<script type="text/javascript" src="scripts/cor-ajax-change.js"></script>';
    
    	$this -> page [ "text" ] .= '<link rel="stylesheet" type="text/css" href="styles/cor-users.css" charset="UTF-8" media="screen" />
    	<div id="usercontrolmenu">';
    	if ( User::session () -> getPrimaryGroup () <= 2 ) $this -> page [ "text" ] .= '<a href="#" onclick="ajaxDialogue(\''. Localization::session () -> getFile ( "cor-add-user" ) .'.xml\');return false;" class="cor-button-small cor-addUser"><span>'. _( "Přidat uživatele" ) .'</span></a>';
    	if ( User::session () -> getPrimaryGroup () <= 2 ) $this -> page [ "text" ] .= '<a href="#" onclick="ajaxDialogue(\''. Localization::session () -> getFile ( "cor-add-group" ) .'.xml\');return false;" class="cor-button-small cor-addGroup"><span>'. _( "Přidat skupinu" ) .'</span></a>';
    	//$this -> page [ "text" ] .= '<a href="#" class="cor-button-small cor-searchUser"><span>'. _( "Hledat uživatele" ) .'</span></a>';
    	$this -> page [ "text" ] .= '
    	    <img class="invisible" src="styles/cor-admin/add-user-over.jpg" alt="hidden part of content" />
    	    <img class="invisible" src="styles/cor-admin/add-group-over.jpg" alt="hidden part of content" />
    	    <img class="invisible" src="styles/cor-admin/search-user-over.jpg" alt="hidden part of content" />
    	</div>
    	<hr class="cleaner" />';

    	$numberOfUsers = Database::connection () -> getResult ( "SELECT COUNT(*) FROM users;" );
    	$numberOfActiveUsers = Database::connection () -> getResult ( "SELECT COUNT(*) FROM users WHERE logedout=0;" );

	$this -> page [ "text" ] .= '<table class="table">
    	<caption>'. _( "Statistika uživatelů" ) .'</caption>
	<tr><td></td><th>'. _( "počet" ) .'</th><th>'. _( "aktivních" ) .'</th></tr>
	<tr><th>'. _( "Všichni" ) .'</th><td>'. $numberOfUsers .'</td><td>'. $numberOfActiveUsers .'</td></tr>';

    	if ( User::session () -> getPrimaryGroup () == 1 ) {
    	    $numberOfAdministrators = Database::connection () -> getResult ( "SELECT COUNT(*) FROM membersofgroups WHERE groupid=1;" );
    	    $numberOfActiveAdministrators = "?";
    	    $this -> page [ "text" ] .= '<tr><th><a href="'. Tools::getFullpage () .'?show=1" title="'. _( "Seznam administratorů" ) .'">'. _( "Administrátoři" ) .'</a></th><td>'. $numberOfAdministrators .'</td><td>'. $numberOfActiveAdministrators .'</td></tr>';
    	}

    	if ( User::session () -> getPrimaryGroup () <= 2 ) {
    	    $numberOfWebmasters = Database::connection () -> getResult ( "SELECT COUNT(*) FROM membersofgroups WHERE groupid=2;" );
    	    $numberOfActiveWebmasters = "?";
    	    $this -> page [ "text" ] .= '<tr><th><a href="'. Tools::getFullpage () .'?show=2" title="'. _( "Seznam webmasterů" ) .'">'. _( "Webmasteři" ) .'</a></th><td>'. $numberOfWebmasters .'</td><td>'. $numberOfActiveWebmasters .'</td></tr>';
    	}

    	if ( User::session () -> getPrimaryGroup () <= 3 ) {
    	    $numberOfWriters = Database::connection () -> getResult ( "SELECT COUNT(*) FROM membersofgroups WHERE groupid=3;" );
    	    $numberOfActiveWriters = "?";
    	    $this -> page [ "text" ] .= '<tr><th><a href="'. Tools::getFullpage () .'?show=3" title="'. _( "Seznam spisovatelů" ) .'">'. _( "Spisovatelé" ) .'</a></th><td>'. $numberOfWriters .'</td><td>'. $numberOfActiveWriters .'</td></tr>';
    	}

    	$numberOfOthers = Database::connection () -> getResult ( "SELECT COUNT(*) FROM membersofgroups WHERE groupid=4;" );
    	$numberOfActiveOthers = "?";
    	$this -> page [ "text" ] .= '<tr><th><a href="'. Tools::getFullpage () .'?show=4" title="'. _( "Seznam uživatelů" ) .'">'. _( "Běžní uživatelé" ) .'</a.</th><td>'. $numberOfOthers .'</td><td>'. $numberOfActiveOthers .'</td></tr>';

    	$this -> page [ "text" ] .= '</table>';
    	
    }

    private function showgroups ()
    {

	$this -> page [ "text" ] = "<h3>". _( "Přidat skupinu:" ) ."</h3>";

    	$usersgroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups WHERE id>4;" );

    	$userid = (int) $_GET [ "userid" ];
// pridat potvrzovaci ajax dialog pro zmenu primarni skupiny
    	if ( $userid != User::session () -> getId () ) {
	    $prim_group = Database::connection () -> getResult ( "SELECT groupid FROM membersofgroups WHERE userid=$userid AND groupid<=4;" );
	    if ( $prim_group != 1 && ( $prim_group != 2 || User::session () -> getPrimaryGroup () == 1 ) ) {
	    	if ( User::session () -> getPrimaryGroup () == 1 ) {
    	    	    $usersgroups [] = array ( "id" => 1, "usergroup" => _( "Administrátoři" ) );
    		}
    		$usersgroups [] = array ( "id" => 2, "usergroup" => _( "Webmasteři" ) );
    		$usersgroups [] = array ( "id" => 3, "usergroup" => _( "Spisovatelé" ) );
    		$usersgroups [] = array ( "id" => 4, "usergroup" => _( "Uživatelé" ) );
	    }
	}

	$this -> page [ "text" ] .= '<ul>';
	foreach ( $usersgroups as $group ) {
	    $this -> page [ "text" ] .= '<li><a href="#" onclick="ajaxDialogue(\''. Tools::getpage () .'.xml?addgroup='. $group [ "id" ] .'&amp;user='. $userid .'\');return false;" title="'. _( "Přidat skupinu" ) .'">'. $group [ "usergroup" ] .'</a></li>';
	}
	$this -> page [ "text" ] .= '</ul>';
    } // end showgroups

    private function showUser ( $input_user )
    {
    	$user_id = (int) $input_user;

	if ( $_GET [ "addgroup" ] ) {
	    $new_group = (int) $_GET [ "addgroup" ];
	    if ( ( $new_group < 5 ) && ( $user_id == User::session () -> getId () ) ) {
	    	$this -> page [ "text" ] .= '<strong class="warning">'. _( "Nelze změnit primární skupinu sám sobě." ) .'</strong>';
	    } else {
	    	$prim_group = Database::connection () -> getResult ( "SELECT groupid FROM membersofgroups WHERE userid=$user_id AND groupid<=4;" );
	    	if ( $new_group < 5 && $prim_group == 1 ) {
	    	    $this -> page [ "text" ] .= '<strong class="warning">'. _( "Nelze změnit primární skupinu administrátorům." ) .'</strong>';
	    	} elseif ( $new_group < 5 && $prim_group == 2 && User::session () -> getPrimaryGroup () != 1 ) {
	    	    $this -> page [ "text" ] .= '<strong class="warning">'. _( "Webmasterům může změnit skupinu jen administrátor." ) .'</strong>';
	    	} elseif ( $new_group < 5 && Database::connection () -> query ( "UPDATE membersofgroups SET groupid=$new_group WHERE userid=$user_id AND groupid=$prim_group;" ) ) {
	    	    $this -> page [ "text" ] .= '<strong class="success">'. _( "Primární skupina byla úspěšně změněna." ) .'</strong>';
	    	} elseif ( Database::connection () -> query ( "INSERT INTO membersofgroups VALUES ( $user_id, $new_group );" ) ) {
	    	    $this -> page [ "text" ] .= '<strong class="success">'. _( "Skupina byla úspěšně změněna." ) .'</strong>';
	    	} else {
	    	    $this -> page [ "text" ] .= '<strong class="warning">'. _( "Nepodařilo se změnit skupinu." ) .'</strong>';
	    	}
	    }
	}
    	
    	$user = Database::connection () -> fetch_assoc ( "SELECT * FROM users WHERE id=$user_id;" );
    	if ( !is_array ( $user ) ) {
    	    Error::ticket () -> notice ( 'cor00032', 'in ' .__FILE__. ' on line ' .__LINE__, "wanted users id is $user_id" );
    	    return;
    	}

    	$user [ "primary_group" ] = Database::connection () -> getResult ( "SELECT groupid FROM membersofgroups WHERE userid=$user_id AND groupid<=4;" );
    	if ( $user [ "primary_group" ] < User::session () -> getPrimaryGroup () ) {
    	    Error::ticket () -> notice ( 'cor00032', 'in ' .__FILE__. ' on line ' .__LINE__, "wanted users id is $user_id" );
    	    return;
    	}

	$encoded_nick = urlencode ( $user [ "nick" ] );
    	if ( file_exists ( "images/users-icons/$encoded_nick-big.jpg" ) )
    	    $user_icon = "images/users-icons/$encoded_nick-big.jpg";
    	elseif ( file_exists ( "images/users-icons/$encoded_nick-big.gif" ) )
    	    $user_icon = "images/users-icons/$encoded_nick-big.gif";
    	elseif ( file_exists ( "images/users-icons/$encoded_nick-big.png" ) )
    	    $user_icon = "images/users-icons/$encoded_nick-big.png";
    	else
    	    $user_icon = "images/users-icons/free-icons/blue-user-big.jpg";

    	$this -> page [ "title" ] = _( "Uživatel" ) ." ". $user [ "nick" ];
    	$this -> page [ "text" ] .= '<img src="'. $user_icon .'" alt="'. _( "Ikona uživatele" ) .'" class="objectLeft" />';
    	$this -> page [ "text" ] .= '<div class="cor-greatIconLeft">';
    	$this -> page [ "text" ] .= '<ul>';
    	$this -> page [ "text" ] .= '<li><strong>'. _( "Přezdívka:" ) .'</strong> '. $user [ "nick" ] .'</li>';
    	$this -> page [ "text" ] .= '<li><strong>'. _( "Občanské jméno:" ) .'</strong> '. $user [ "fullname" ] .'</li>';
    	$this -> page [ "text" ] .= '<li><strong>'. _( "Registrován od:" ) .'</strong> '. Tools::getRightDate ( $user [ "registered" ], false ) .'</li>';
    	$this -> page [ "text" ] .= '</ul>';
    	$this -> page [ "text" ] .= '<h3>'. _( "Členem ve skupinách:" ) .'</h3>';

	$usersgroups = Database::connection () -> fetchall_assoc ( "SELECT * FROM usergroups WHERE id IN (SELECT groupid FROM membersofgroups WHERE userid=". $user [ "id" ] .");" );

	$this -> page [ "text" ] .= '<ul>';
	foreach ( $usersgroups as $group ) {
	    $this -> page [ "text" ] .= '<li><a href="'. Tools::getFullpage () .'?show='. $group [ "id" ] .'" title="'. _( "Seznam uživatelů ve skupině" ) .'">'. $group [ "usergroup" ] .'</a>'. ( ( $user [ "primary_group" ] > User::session () -> getPrimaryGroup () && User::session () -> getPrimaryGroup () <= 2 && $user [ "primary_group" ] > 4 ) ? ' - <a href="'. Tools::getFullpage () .'?dropgroup='. $group [ "id" ] .'" title="'. _( "Odebrat uživateli skupinu" ) .'">'. _( "odebrat" ) .'</a>' : '' ) .'</li>';
	}
	$this -> page [ "text" ] .= '</ul>
	</div>';

	if ( $user [ "primary_group" ] >= User::session () -> getPrimaryGroup () && User::session () -> getPrimaryGroup () <= 2 && User::session () -> getId () != 0 ) {
	    $this -> page [ "text" ] .= '<a href="#" title="'. _( "Přidat skupinu" ) .'" onclick="changeIdByGET(\''. Tools::getPage () .'.xml?showgroups=all&amp;userid='. $user [ "id" ] .'\',\'addgroups\');$(this).hide();return false;">'. _( "Přidat skupinu" ) .'</a>
	    <div id="addgroups" class="cor-greatIconLeft">&nbsp;</div>';
	}

    	$this -> page [ "text" ] .= '<hr class="cleaner" />';
    	$this -> page [ "text" ] .= '<br /><input type="button" class="dialogue-button" onclick="location.reload(true);" value="'. _( "Zavřít" ) .'" />';
    }

    private function showUsers ( $group ) {

	$this -> page [ "title" ] = _( "Uživatelé ve skupině" ) .' '. Database::connection () -> getResult ( "SELECT usergroup FROM usergroups WHERE id=$group;" );
    	$numberOfUsers = Database::connection () -> getResult ( "SELECT COUNT(*) FROM membersofgroups WHERE groupid=$group;" );
    	$this -> page [ "text" ] .= '<a href="'. Tools::getFullPage () .'" title="'. _( "Zpět na správu uživatelů" ) .'">'. _( "Zpět na správu uživatelů" ) .'</a>
    	<p><strong>'. _( "Počet uživatelů ve skupině" ) .'</strong>: '. $numberOfUsers .'</p>';

    	$from = ( isset ( $_GET [ "from" ] ) ) ? (int) $_GET [ "from" ] : 0;

    	$users = Database::connection () -> fetchall_assoc ( "SELECT * FROM users WHERE id IN (SELECT userid FROM membersofgroups WHERE groupid=$group) LIMIT $from, 10;" );

	if ( is_array ( $users ) ) {
	    $this -> page [ "text" ] .= '<script type="text/javascript" src="scripts/cor-ajax-change.js"></script>
	    <table class="table">
	    <tr><th>'. _( "Přezdívka" ) .'</th><th>'. _( "Jméno" ) .'</th><th>'. _( "Registrovaný" ) .'</th><th>'. _( "Jazyk" ) .'</th></tr>';
    	    foreach ( $users as $user ) {
    		$this -> page [ "text" ] .= '<tr><td><a href="#" onclick="ajaxDialogue(\''. Tools::getPage () .'.xml?user='. $user [ "id" ] .'\');return false;" title="'. _( "Ukaž uživatele" ) .'">'. $user [ "nick" ] .'</a></td>
    		<td>'. $user [ "fullname" ] .'</td><td>'. Tools::getRightDate ( $user [ "registered" ] ) .'</td><td>'. $user [ "language" ] .'</td></tr>';
    	    }
    	    $this -> page [ "text" ] .= '</table>';
    	}

    	if ( $numberOfUsers > 10 ) {
    	    // pridat zanorovani
    	}

    } // end showUsers

}

$UserControl = new UserControl ();
$page = $UserControl -> page;
?>