<?php
/* **************************************************************************** *

 * cor-web-contents.php								*
 * @package	Core								*
 * @copyright	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*

 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Script for managing structure of articles in Albireo.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */
require "cor-contents.php";

class WebContents extends Contents {

    public $page = array ( "text" => "" );
    private $corarticles;

    public function __construct ()
    {
    	
    	$this -> corarticles = Localization::session () -> getFile ( "cor-articles", false );
    	
    	if ( isset ( $_GET [ "contentdir" ], $_GET [ "side" ] ) && ( $_GET [ "side" ] == "left" || $_GET [ "side" ] == "right" )  ) {
    	    $this -> page [ "text" ] = $this -> showDir ( $_GET [ "contentdir" ], $_GET [ "side" ] );
    	} else {

	    // gets php code common to all pages of contents
    	    parent::__construct ();
    	    
    	    $this -> page [ "text" ] .= '
    	    <link rel="stylesheet" type="text/css" href="styles/xin.css" charset="UTF-8" media="screen" />
			
	    <script type="text/javascript" src="scripts/tool-man/core.js"></script>
	    <script type="text/javascript" src="scripts/tool-man/events.js"></script>
	    <script type="text/javascript" src="scripts/tool-man/css.js"></script>
	    <script type="text/javascript" src="scripts/tool-man/coordinates.js"></script>
	    <script type="text/javascript" src="scripts/tool-man/drag.js"></script>
	    <script type="text/javascript" src="scripts/tool-man/dragsort.js"></script>
	    <script type="text/javascript" src="scripts/tool-man/cookies.js"></script>
	    <script type="text/javascript" src="scripts/cor-toolman.js"></script>

	    <script type="text/javascript" src="scripts/cor-file-sorting.js.php"></script>
    	    <script type="text/javascript">
		
		function jsquery ( side ) {
		var baseorder = junkdrawer.inspectListOrder ( side +\'SortFiles\');
		var arraysplit = baseorder.split ( "|" );
		for ( var i = 0; i < arraysplit.length; i++ ) {
		    order = arraysplit [ i ];
		    var start = order.indexOf ( ">" );  
		    var end = order.lastIndexOf ( "<" );  
		    order = order.substring ( start+1, end );
		    start = order.indexOf ( ">" );
		    end = order.lastIndexOf ( "<" );
		    arraysplit [ i ] = order.substring ( start+1, end );
		} 
		    finish = arraysplit.join ( "|" );
		    ajaxDialogue ( "xml.php?page='.$this -> corarticles.'&action=sort&list="+finish );
		    endsort ( side );
		}
	    </script>';

    	    if ( isset ( $_GET [ "action" ] ) ) { // creating and editing od articles
    	 	$this -> manageArticle ();
    	    }

        if ( empty ( $_GET [ "action" ] ) || $_GET [ "action" ] != "sort" ) {

	    $leftDirId = ( isset ( $_GET [ "leftdir" ] ) ) ? (int) $_GET [ "leftdir" ] : 0;
	    $rightDirId = ( isset ( $_GET [ "rightdir" ] ) ) ? (int) $_GET [ "rightdir" ] : 0;

	    $this -> page [ "text" ] .= '<script type="text/javascript">
	    directoryContent.leftDirId = '. $leftDirId .';
	    directoryContent.rightDirId = '. $rightDirId .';
	    </script>';

	    $this -> page [ "text" ] .= '<div class="floatLeft">
	    <a href="#" class="cor-button-small cor-filenew" onclick="directoryContent.destroyObjectActions();ajaxDialogue(\''. $this -> corarticles .'.xml?action=newarticle&#038;dirid=\'+directoryContent.leftDirId);resizeDialogue();return false;"><span>'. _( 'Nový článek' ) .'</span></a><br />
	    <a href="#" class="cor-button-small cor-foldernew" onclick="directoryContent.destroyObjectActions();ajaxDialogue(\'xml.php?page='. $this -> corarticles .'&#038;action=newfolder&#038;dirid=\'+directoryContent.leftDirId);return false;"><span>'. _( 'Nová složka' ) .'</span></a>
		<div id="left-sorting">
		<a href="#" class="cor-button-small cor-order" onclick="sort(\'left\');junkdrawer.restoreListOrder(\'leftSortFiles\');dragsort.makeListSortable(document.getElementById(\'leftSortFiles\'));return false;"><span>'. _( 'Třídit obsah' ) .'</span></a>
		</div>
	    </div>

	    <div class="floatRight">
     	    <a href="#" class="cor-button-small cor-filenew" onclick="directoryContent.destroyObjectActions();ajaxDialogue(\''. $this -> corarticles .'.xml?action=newarticle&#038;dirid=\'+directoryContent.rightDirId);resizeDialogue();return false;"><span>'. _( 'Nový článek' ) .'</span></a><br />
    	    <a href="#" class="cor-button-small cor-foldernew" onclick="directoryContent.destroyObjectActions();ajaxDialogue(\'xml.php?page='. $this -> corarticles .'&#038;action=newfolder&#038;dirid=\'+directoryContent.rightDirId);return false;"><span>'. _( 'Nová složka' ) .'</span></a>
	    <div id="right-sorting">
	    <a href="#" class="cor-button-small cor-order" onclick="sort(\'right\');junkdrawer.restoreListOrder(\'rightSortFiles\');dragsort.makeListSortable(document.getElementById(\'rightSortFiles\'));return false;"><span>'. _( 'Třídit obsah' ) .'</span></a>
	    </div>
    	    </div>

    	    <div id="cor-contentdir-head" onclick="directoryContent.destroyObjectActions();">
    	    <div class="floatLeft cor-contentdir"><div id="leftContentWindow">'. $this -> showDir ( $leftDirId, "left" ) .'</div></div>
    	    <div class="floatLeft cor-contentdir"><div id="rightContentWindow">'. $this -> showDir ( $rightDirId, "right" ) .'</div></div>
    	    </div>

    	    <img class="invisible" src="styles/cor-admin/folder_open.jpg" alt="hidden part of content" />
    	    <img class="invisible" src="styles/cor-admin/article-over.jpg" alt="hidden part of content" />
    	    <img class="invisible" src="styles/cor-admin/filenew-over.jpg" alt="hidden part of content" />
    	    <img class="invisible" src="styles/cor-admin/order-over.jpg" alt="hidden part of content" />
    	    <hr class="cleaner" />';
		}

    	}
    } // end __construct

    private function showDir ( $dirNumber, $side )
    {
    	$dirNumber = (int) $dirNumber;
    	$parent_dir = Database::connection () -> fetch_assoc ( "SELECT * FROM directory WHERE id=$dirNumber;" );
    	// access checking ///////////////////////////////////////////////////////////
	if ( $dirNumber != 0 ) {
	    if ( !SecurityTools::check_read ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
	    	Error::ticket () -> notice ( 'cor00028', 'in '. __FILE__ .' on line '. __LINE__ , Tools::getFullPage () ." ". User::session () -> getNick () );
	    }
	}
	//////////////////////////////////////////////////////////////////////////////
	$dir_content = Database::connection () -> fetchall_assoc ( "SELECT * FROM directory WHERE parent=$dirNumber ORDER BY sequence;" );
    	$article_content = Database::connection () -> fetchall_assoc ( "SELECT * FROM header WHERE directory=$dirNumber ORDER BY sequence;" );
    	$draft_content = Database::connection () -> fetchall_assoc ( "SELECT * FROM drafts WHERE directory=$dirNumber;" );
    	$content = '';
    	
    	if ( $dirNumber != 0 ) {
    	    $content .= $this -> createHTMLDir ( $parent_dir, $side, $parent = true );
    	}

	if ( !is_array ( $dir_content ) && !is_array ( $article_content ) && !is_array ( $draft_content ) ) {
	    return $content . _( '<p><strong class="warning">Složka je prázdná...</strong></p>' );
	}
	$content .= '<ul id="'.$side.'SortFiles">';
	if ( is_array ( $dir_content ) ) {
    	    foreach ( $dir_content as $dir ) {
    	    	$content .= $this -> createHTMLDir ( $dir, $side );
    	    }
    	}

    	if ( is_array ( $article_content ) ) {
    	    foreach ( $article_content as $article ) {
    	    	$content .= $this -> createHTMLArticle ( $article, $side );
    	    }
    	}

    	if ( is_array ( $draft_content ) ) {
    	    foreach ( $draft_content as $draft ) {
    	    	$content .= $this -> createHTMLDraft ( $draft, $side );
    	    }
    	}
		$content .= '</ul>';
    	return $content;
    } // end showDir

    private function createHTMLDraft ( $draft, $side ) {
    	if ( !SecurityTools::check_read ( "wr0", $draft [ "author" ], 2 ) ) {
    	    return; // user doesn`t have permission to read this directory
    	}
    	$title = ( strlen ( $draft [ "title" ] ) > 28 || ( strlen ( $draft [ "title" ] ) > 14 && stripos ( substr ( $draft [ "title" ], 0, 12 ), " " ) === false ) ) ? substr ( $draft [ "title" ], 0, 11 ) ."..." : $draft [ "title" ];
    	return '<li class="box"><a href="#" class="cor-button cor-articleDraftButton" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'draft\','. $draft [ "id" ] .',\''. $this -> corarticles .'\');return false;" ondblclick="ajaxDialogue(\'xml.php?page='. $this -> corarticles .'&#038;action=showdraft&#038;id='. $draft [ "id" ] .'\');"><span>'. $title .'</span></a></li>';
    } // end createHTMLDraft

    private function createHTMLDir ( $dir, $side, $parent = false )
    {
    	if ( !SecurityTools::check_read ( $dir [ "access" ], $dir [ "author" ], $dir [ "groupid" ] ) ) {
    	    return; // user doesn`t have permission to read this directory
    	}
    	if ( $parent == true ) {
    	    return '<a href="#" class="cor-button cor-dirButton" onclick="return false;" oncontextmenu="return false;" ondblclick="directoryContent.getDirectoryContent(\'xml.php?page='.
    	    Tools::getPage () .'&#038;contentdir='. $dir [ "parent" ] .'&#038;side='. $side. '\',\''. $side .'\','. $dir [ "parent" ] .');endsort(\''. $side .'\');"><span>'.
    	    _( '..nahoru' ) .'</span></a>';
    	} else {
    	    $title = ( strlen ( $dir [ "title" ] ) > 28 || ( strlen ( $dir [ "title" ] ) > 14 && stripos ( substr ( $dir [ "title" ], 0, 12 ), " " ) === false ) ) ? substr ( $dir [ "title" ], 0, 11 ) ."..." : $dir [ "title" ];
    	    return '<li class="box"><a href="#" class="cor-button cor-dirButton" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'directory\','. $dir [ "id" ] .',\''. $this -> corarticles .'\');return false;" ondblclick="directoryContent.getDirectoryContent(\'xml.php?page='.
    	    Tools::getPage () .'&#038;contentdir='. $dir [ "id" ] .'&#038;side='. $side. '\',\''. $side .'\','. $dir [ "id" ] .');endsort(\''. $side .'\');"><span>'. $title .'</span></a></li>';
    	}
    } // end createHTMLDir

    private function createHTMLArticle ( $article, $side )
    {
    	if ( !SecurityTools::check_read ( $article [ "access" ], $article [ "author" ], $article [ "groupid" ] ) ) {
    	    return; // user doesn`t have permission to read this article
    	}
    	$title = ( strlen ( $article [ "anchor" ] ) > 28 || ( strlen ( $article [ "anchor" ] ) > 14 && stripos ( substr ( $article [ "anchor" ], 0, 12 ), " " ) === false ) ) ? substr ( $article [ "anchor" ], 0, 11 ) ."..." : $article [ "anchor" ];
    	if ( $article [ "type" ] == "script" ) {
    	    return '<li class="box"><a href="#" class="cor-button cor-articleScriptButton" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'article\','. $article [ "id" ] .',\''. $this -> corarticles .'\');return false;" ondblclick="ajaxDialogue(\'xml.php?page='.
    	    $this -> corarticles .'&#038;id='. $article [ "id" ] .'\');"><span>'. $title .'</span></a></li>';
    	} else {
    	    return '<li class="box"><a href="#" class="cor-button cor-articleButton" onclick="return false;" oncontextmenu="directoryContent.onrightclickActions(event,\'article\','. $article [ "id" ] .',\''. $this -> corarticles .'\');return false;" ondblclick="ajaxDialogue(\'xml.php?page='.
    	    $this -> corarticles .'&#038;action=editarticleinfo&#038;id='. $article [ "id" ] .'\');"><span>'. $title .'</span></a></li>';
    	}
    } // end createHTMLArticle

    private function manageArticle ()
    {
    	if ( $_GET [ "action" ] == "newarticle" ) {
    	    switch ( $_GET [ "step" ] ) {
    	    	case "step2":
    	    	    $this -> articleBody ();
    	    	    break;
    	    }
    	}
    	if ( $_GET [ "action" ] == "editarticle" ) {
    	    $this -> editArticle ();
    	}
    } // end manageArticle

    private function editArticle () {
    	// access checking ///////////////////////////////////////////////////////////
    	$access_article = Database::connection () -> fetch_assoc ( "SELECT author, groupid, access FROM header WHERE id=". (int) $_GET [ "id" ] .";" );
	if ( !SecurityTools::check_write ( $access_article [ "access" ], $access_article [ "author" ], $access_article [ "groupid" ] ) ) {
	    $this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nemáte povolen zápis do této složky" ) .'!</strong></p>';
	    return;
	}
	//////////////////////////////////////////////////////////////////////////////
	if ( isset ( $_POST [ "editorial" ], $_POST [ "texts" ], $_POST [ "title" ], $_GET [ "id" ] ) ) {
    	    $editorial = htmlspecialchars ( $_POST [ "editorial" ] );
	    $text = $this -> clearTags ( stripslashes ( $_POST [ "texts" ] ) );
	    $title = htmlspecialchars ( $_POST [ "title" ] );
	    if ( Database::connection () -> query ( "UPDATE header SET title='$title' WHERE id=". (int) $_GET [ "id" ] .";" ) &&
	    	 Database::connection () -> query ( "UPDATE content SET editorial='$editorial', text='$text' WHERE id_header=". (int) $_GET [ "id" ] .";" ) ) {
	    	$this -> page [ "text" ] .= '<script type="text/javascript"> okDialogue (\''. _( "Článek editován" ) .'\',\''. _( "Článek byl úspěšně editován" ) .'.\'); </script>';
	    } else {
	    	$this -> page [ "text" ] .= '<p><strong class="warning">'. _( "Nepodařilo se editovat článek" ) .' '. (int) $_GET [ "id" ] .'.</strong></p>';
	    }
	}
    } // end editArticle

    private function articleBody ()
    {

    	// access checking ///////////////////////////////////////////////////////////
	$parent_dir = Database::connection () -> fetch_assoc ( "SELECT author, groupid, access FROM directory WHERE id=". (int) $_GET [ "directory" ] .";" );
	if ( !SecurityTools::check_write ( $parent_dir [ "access" ], $parent_dir [ "author" ], $parent_dir [ "groupid" ] ) ) {
	    Error::ticket () -> notice ( 'cor00029', 'in '. __FILE__ .' on line '. __LINE__ , Tools::getFullPage () ." ". User::session () -> getNick () );
	}
	//////////////////////////////////////////////////////////////////////////////

    	if ( isset ( $GET [ "draftid" ] ) ) {
    	} else {
    	    $title = htmlspecialchars ( $_POST [ "title" ] );
    	    $author = User::session () -> getId ();
    	    $directory = (int) $_POST [ "directory" ];
    	    $editorial = htmlspecialchars ( $_POST [ "editorial" ] );
    	    $text = $this -> clearTags ( addslashes ( $_POST [ "texts" ] ) );

    	    if ( Database::connection () -> query ( "INSERT INTO drafts VALUES ( 0, 'static', '$title', $author, CURRENT_TIMESTAMP(), $directory, '$editorial', '$text', 'cs' );" ) ) {
    	    	$draftid = Database::connection () -> getResult ( "SELECT LAST_INSERT_ID();" );
    	    } else {
    	    	$this -> page [ "text" ] = '<p><strong class="warning">'. _( "Nepodařilo se uložit článek do konceptů!" ) .'</strong></p>
    	    	<input type="button" class="dialogue-button" onclick="closeDialogueWindow();" value="OK" />';
    	    	return;
    	    }
    	}
	$this -> page [ "text" ] .= '<script type="text/javascript"> ajaxDialogue(\'xml.php?page='. $this -> corarticles .'&action=articlestep2&draftid='. $draftid .'\'); </script>';
    } // end articleBody

    function clearTags ( $text )
    {
    	$begin = strpos ( $text, "<!--" );
    	$end = strpos ( $text, "-->", $begin );
    	while ( $begin !== false && $end !== false ) {
    	    $text = substr_replace ( $text, "", $begin, ( $end - $begin + 3 ) );
    	    $begin = strpos ( $text, "<!--" );
    	    $end = strpos ( $text, "-->", $begin );
    	}
    	$begin = strpos ( $text, "<style" );
    	$end = strpos ( $text, "</style>", $begin );
    	while ( $begin !== false && $end !== false ) {
    	    $text = substr_replace ( $text, "", $begin, ( $end - $begin + 8 ) );
 	    $begin = strpos ( $text, "<style" );
    	    $end = strpos ( $text, "</style>", $begin );
    	}
    	$begin = strpos ( $text, "<meta" );
    	$end = strpos ( $text, ">", $begin );
    	while ( $begin !== false && $end !== false ) {
    	    $text = substr_replace ( $text, "", $begin, ( $end - $begin + 1 ) );
	    $begin = strpos ( $text, "<meta" );
    	    $end = strpos ( $text, ">", $begin );
    	}
    	$begin = strpos ( $text, "<link" );
    	$end = strpos ( $text, ">", $begin );
    	while ( $begin !== false && $end !== false ) {
    	    $text = substr_replace ( $text, "", $begin, ( $end - $begin + 1 ) );
	    $begin = strpos ( $text, "<link" );
    	    $end = strpos ( $text, ">", $begin );
    	}
    	$text = str_replace ( "<o:p />", "", $text );
    	return $text;
    } // clearTags

}

$WebContents = new WebContents ();
$page = $WebContents -> page;
?>