<?php
/* **************************************************************************** *

 * AlbireoUser.inc.php								*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 Class AlbireoUser is called by class User for managing users of Albireo
 administration system.

 Properties:
    none
 	
 Public Methods:
    string getType ()		// show name of class
    string getUserType ()	// show type of user
    string getNick ()		// show nick of user
    string getFullName ()	// show full name of user
    string getEmail ()		// show e-mail of user
    string getLanguage ()	// show language of user`s interface
    int getId ()		// show id of user
    datetime getRegistered ()	// show time of registering
 	
 * **************************************************************************** */
 
class AlbireoUser implements UserInterface {

    private $user;

    public function __construct () {
    	
    	if ( self::isLogedIn () ) {
    	
    	    if ( Tools::getFullPage () == Localization::session () -> getFile ( "cor-log-in" ) ) {
    	    	header ( "Location:". Localization::session () -> getFile ( "cor-overview" ) );
    	    }

    	    if ( Tools::baseSettings () -> getSetting ( "first_administrator_created" ) == "true" &&
    	    	 Database::connection () -> is_connected () ) {
    	    	$this -> user = Database::connection () -> fetch_assoc ( "SELECT * FROM users WHERE id='". (int) $_SESSION [ "sessionid" ] ."';" );
    	    	$this -> user [ "primarygroup" ] = Database::connection () -> getResult ( "SELECT groupid FROM membersofgroups WHERE userid=". $this -> user [ "id" ] ." AND groupid<=4;" );
    	    } else {
		return false;
    	    }
    	    
    	}
    	    
    } // end __construct

    public static function login ( $name, $password )
    {

	$user_name = htmlspecialchars ( $name );
	$user_password = md5 ( $password );

    	if ( $database_password = Database::connection () -> getResult ( "SELECT password FROM users WHERE nick='$user_name';" ) ) {
    	    if ( $database_password == $user_password ) {
    	    	$_SESSION [ "sessionid" ] = Database::connection () -> getResult ( "SELECT id FROM users WHERE nick='$user_name';" );
    	    	if ( Database::connection () -> query ( "UPDATE users SET logedout=0 WHERE nick='$user_name';" ) ) {
		    if ( Database::connection () -> query ( "INSERT INTO logins VALUES ('". $_SESSION [ "sessionid" ] ."', '". $_SERVER [ "REMOTE_ADDR" ] ."', '". getHostByADDR ( $_SERVER [ "REMOTE_ADDR" ] ) ."', '". $_SERVER [ "HTTP_USER_AGENT" ] ."', CURRENT_TIMESTAMP () );" ) ) {
    	    	    	if ( empty ( $_GET [ "loginpage" ] ) ) {
    	    	    	    header ( "Location:". Localization::session () -> getFile ( "cor-overview" ) );
    	    		} else {
    	    	    	    header ( "Location:". $_GET [ "loginpage" ] . Tools::baseSettings () -> getSetting ( "file_extension" ) );
    	    		}
    	    	    } else {
    	    	    	return '<p><strong class="warning">'. _( "Nepodařilo se vložit údaje o vašem přihlášení!" ) .'</strong></p>';
    	    	    }
    	    	} else {
    	    	    return '<p><strong class="warning">'. _( "Nepodařilo se vložit záznam o vašem přihlášení!" ) .'</strong></p>';
    	    	}    	    	
    	    } else {
    	    	return '<p><strong class="warning">'. _( "Špatné heslo!" ) .'</strong></p>';
    	    }
    	} else {
    	    return '<p><strong class="warning">'. $user_name .' - '. _( "Uživatel neexistuje!" ) .'</strong></p>';
    	}
    	
    }

    public static function isLogedIn ()
    {
    	if ( !isset ( $_SESSION ) ) {
    	    if ( !self::ini_session () ) {
    	    	Error::ticket () -> notice ( 'cor00005', 'in '. __FILE__ .' on line '. __LINE__ );
    	    }
    	}
    	if ( isset ( $_SESSION ) && session_is_registered ( "sessionid" ) && self::userIsLogedIn ( $_SESSION [ "sessionid" ] ) ) {
    	    return true;
    	} else {
    	    return false;
    	}
    }

    public static function userIsLogedIn ( $userid )
    {
    	if ( Database::connection () -> getResult ( "SELECT logedout FROM users WHERE id='$userid';" ) == 0 ) {
    	    return true;
    	} else {
    	    return false;
    	}
    }

    private static function ini_session ()
    {
    	@ini_set ( "session.use_only_cookies", 1 );
    	@ini_set ( "session.use_cookies", 1 );
    	if ( session_start () ) {
    	    return true;
    	} else {
    	    return false;
    	}
    } // end ini_session

    public function getFullName ()
    {
    	return $this -> user [ "fullname" ];
    } // end getFullName

    public function getId ()
    {
    	return $this -> user [ "id" ];
    } // end getId

    public function getNick ()
    {
    	return $this -> user [ "nick" ];
    } // end getNick

    public function getType ()
    {
    	return "AlbireoUser";
    } // end getType

    public function getPrimaryGroup ()
    {
    	return $this -> user [ "primarygroup" ];
    } // end getPrimaryGroup

    public function getLanguage ()
    {
    	return $this -> user [ "language" ];
    } // end getLanguage

    public function getEmail ()
    {
    	return $this -> user [ "email" ];
    } // end getEmail
    
}

?>