<?php
/* **************************************************************************** *

 * Error.php									*
 * verze: 1.0.0									*
 * PHP verze: 5									*
 * autor: Martin Novák								*
 * programátoři: Martin Novák							*
 * poslední aktualizace: Martin Novák						*

 Popis:
 Třída Error je vytvořena podle návrhového vzoru Singleton. Přístup k instanci
 je řešen pomocí metody ticket. Pro svoji funkci využívá rozhraní Display.
 Tato třída je volána pokud dojde kdekoli k chybě.

 Vlastnosti:
 	int $status			// uchovává chybový status webu
 	array $errors			// pole chyb
 	array $erros_secrets		// pole tajných částí chyb

 Veřejné API:
    resource ticket ()			// po vzoru singleton uchovává instanci
 					   třídy
    void notice ( $text, $where, $level ) // zaznamenává chyby
    char getErrors ()			// ukazuje chybové hlášení
    
 * **************************************************************************** */

class Error {

    private static $instance = null;
    public $status = 0;
    public $issue;
    public $errors = array ();
    public $errors_secrets = array ();

    public static function ticket ()
    {
    	if ( self::$instance == null ) {
    	    self::$instance = new Error ();
    	}
    	return self::$instance;
    } // end ticket
	
    public function createEmails ()
    {
		/*if ( file_exists ( "sqlite/errors.db" ) ) {
			if ( !$this -> dbh = @sqlite_open ( "sqlite/w4cerrors.db", 0666, $sqlite_chyba )  ) {
	    	    $this -> chyba.='Chyba při pokusu o odeslání e-mailu: Nelze se připojit k databázi.\n';
			}
		}
		else { $this -> chyba.='Chyba při pokusu o odeslání e-mailu: Databáze s chybami neexistuje.\n'; }	
		sqlite_single_query("DELETE emaily");
		$this -> vysledek = Database::connection () -> fetch_assoc ( "SELECT email FROM users WHERE type='administrator';" );
		foreach ( $this -> vysledek as $email ) {
    	    	$dotaz = "INSERT INTO emaily VALUES ('".$email."');";
				if ( !$this -> sqlite_query ( $dotaz ) ) {$this -> chyba.='Nepodařilo se vložit záznam do SQLITE tabulky.\n';}
    	    }
	////FUNKCE EMAIL KTERÁ ODESÍLÁ, DYŽ TAK PŘIDAT CHYBU*/
    } // end createEmails

    private function __construct ()
    {
    } // end __construct

    private function __clone ()
    {
    } // end __clone

    public function notice ( $code, $where, $secret = "" )
    {

	if ( Tools::baseSettings () -> getSetting ( "primary_settings" ) == "true") {
	$message = "";

	    if ( !file_exists ( "sqlite/errors.db" ) ) {
		$message = _( "Chyba při pokusu o vytvoření chybové hlášky: Databáze s chybami neexistuje." );
		$level = 4;
		$type = 7;
	    } else {
	    	if ( !$this -> dbh = @sqlite_open ( "sqlite/errors.db", 0666, $sqlite_error )  ) {
	    	    $message = _( "Chyba při pokusu o vytvoření chybové hlášky: Nelze se připojit k databázi s chybami - " ) . $sqlite_error;
	    	    $level = 4;
		    $type = 7;
		} else {
		    $result = @sqlite_query ( "SELECT level, type FROM errors WHERE code='". $code ."'", $this -> dbh );
		    $error_array = sqlite_fetch_array ( $result );
		    if ( $error_array [ "level" ] != null && $error_array [ "type" ] != null ) {
			$level = $error_array [ "level" ];
			$type = $error_array [ "type" ];
			if ( !$result = @sqlite_single_query ( "SELECT info FROM cztype WHERE type=". $type, $this -> dbh ) ) {
			    $message .= _( 'Chyba: Nelze vybrat typ chyby' ) ." ";
			    $secret .= "\n". _( "Typ chyby:" ) ." ". $type;
		   	}
		    	$message .= $result;
	
		    	if ( $result = @sqlite_single_query ( "SELECT info FROM czcode WHERE code='". $code ."'", $this -> dbh ) ) {
			    $message .= " : ". $result;
		    	} else {
		    	    $message .= " : ". _( "Chyba: Nelze vybrat info chyby" );
		    	    $secret .= "\n". _( "Kód chyby:" ) ." ". $code;
		    	}
		    } else {
		    	$message = _( "Chyba: Nelze vybrat chybu z databáze" );
		    	$secret .= "\n". _( "Kód chyby:" ) ." ". $code;
		    	$level = 4;
		    	$type = 7;
		    }
		    
		}
	    }

    	    /* *** error level table **************
    	    0	no error		none
    	    1	warning			orange
    	    2	error			blue
    	    3	database error		green
    	    4	critical error		red
    	    5	security error		gold
    	    ************************************ */

    	    switch ( $level ) {
    	    	case 1:
    	    	    $color = ' class="orange"';
    	    	    break;
    	    	case 2:
    	    	    $color = ' class="blue"';
    	    	    break;
    	    	case 3:
    	    	    $color = ' class="green"';
    	    	    break;
    	    	case 4:
    	    	    $color = ' class="red"';
    	    	    break;
    	    	case 5:
    	    	    $color = ' class="gold"';
    	    	    break;
    	    }

    	    $this -> errors [ $message ] = $color;
    	    $this -> errors_secrets [ $where ] = $secret .' '. $where;

	    if ( Database::connection () -> is_connected () ) {
		$this -> log ($code, $where, $secret, $type, $level);
	    } else  {
		 // $this -> backup ( $code, $where, $secret, $type, $level );
	    }

    	    if ( $this -> status < $level ) {
    	    	$this -> status = $level;
    	    	if ( $level > 3 ) {
		    //$this -> email ($code, $where, $secret, $type, $level);
		    if ( $level == 5 ) {
		    	$_SESSION = array();
        		session_destroy();
		    }

		    if ( substr ( $_SERVER [ "SCRIPT_NAME" ], -7 ) == "xml.php" ) {
		    	XMLPublisher::publish ();
		    } else {
		    	XHTMLPublisher::publish ();
		    }
		    exit;
		}
    	    }
	 }
    } // end notice
	
    private function log ( $code, $where, $secret, $type, $level)
    {
		$ip = $_SERVER [ "REMOTE_ADDR" ];

		if ($type!=2) {
			if (!Database::connection () -> query ("INSERT INTO logerrors (code,time,userid,ip,agent,position,secret,type,level) VALUES ('".$code."',NOW(),".User::session () -> getId ().",'".$ip."','".$_SERVER['HTTP_USER_AGENT']."','".$where."','".$secret."',".$type.",".$level.") ")) {
				//$this -> backup ( $code, $where, $secret, $type, $level );
			}
		}
		else {
			//$this -> backup ( $code, $where, $secret, $type, $level );
		}
		
    } // end log
	
	private function email ( $code, $where, $secret, $type, $level)
    {
		if (($level>=4) || ($type==2) ){
			if ($this -> result = @sqlite_query ( "SELECT code,time FROM kody WHERE code='".$code."'", $this->dbh ) ) {
				$pole = sqlite_fetch_array($this -> result);
				$kod = $pole["code"];
				$time = $pole["time"];
				if ($time+3600*24>=Time()) {
					sqlite_single_query ( "UPDATE kody SET time=".$time()." WHERE code='".$code."'", $this->dbh );
				}
				else {
					return false;
				}
			}
			else {
			sqlite_single_query ( "INSERT INTO kody VALUES ('".$code."',".Time().")", $this->dbh );
			}
		 	if ($this -> result = @sqlite_query ( "SELECT email FROM emaily", $this->dbh ) ) {
				foreach ($this->result as $em) {
					$seznam[]=$em;
				}
				$sub= "Došlo k chybě s kódovým označením $code.";
				$message = "Zpráva"; //VYPLNIT TY KECY!!!!!!
				foreach ( $seznam as $email ) {
					if (!(mail($email,$sub,$mes))) {$this -> chyba.='Chyba: Nelze odeslat email.';}
				}
				
			}
			else {
				$this -> chyba.='Chyba: Nelze vybrat emailové adresy.';
			}
		}
		
    } // end email
	
	private function backup ( $code, $where, $secret, $type, $level  )
	{
	  if (file_exists("log/log.txt"))
	   {
	    $fp = fopen ("log/log.txt","a");
	   }
	  else
	   {
	    $fp = fopen ("log/log.txt","w");
		//FPutS($fp,"code | time | userid | ip | agent | position | secret | type | level\n");
		FPutS($fp,"code | time | ip | agent | position | secret | type | level\n");
	   }
	  //FPutS($fp,$code." | ".date("d.m.y H:i:s")." | ".User::session () -> getId ()." | ".$ip." | ".$_SERVER['HTTP_USER_AGENT']." | ".$where." | ".$secret." | ".$type." | ".$level."\n");
	  FPutS($fp,$code." | ".date("d.m.y H:i:s")." | ".$ip." | ".$_SERVER['HTTP_USER_AGENT']." | ".$where." | ".$secret." | ".$type." | ".$level."\n");
	  FClose($fp);
	}
	    
    public function getErrors ()
    {
    	$error = '<ul>';
    	if ( User::session () -> getPrimaryGroup () != 1  ) {
    	    foreach ( $this -> errors as $chyba => $color ) {
    	    	$error .= '<li'.$color.'><strong>'. $chyba .'</strong></li>';
    	    }
	    if ( isset ( $this -> chyba ) ) {
		$error .= '<li><strong>'. $this->chyba .'</strong></li>';
	    }
    	} else {
    	    foreach ( $this -> errors as $chyba => $color ) {
    	    	$error .= '<li'.$color.'><strong>'.$chyba.'</strong> <br />'.current ( $this -> errors_secrets ).'</li>';
    	    	next ( $this -> errors_secrets );
    	    }
 	    if ( isset ( $this -> chyba ) ) {
		$error .= '<li><strong>'. $this->chyba .'</strong></li>';
	    }
			
    	}
    	return $error.'</ul>';	
    } // end getErrors
    
}

?>