<?php
/* **************************************************************************** *

 * ErrorPage.inc.php								*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 Class ErrorPage is called after fatal or security error.

 Properties:
    none
 	
 Public Methods:
    string getAccess ()		// show access of requested page
    string getType ()		// show name of class
    string getText ()		// show text of requested page
    string getTitle ()		// show title of requested page
    string getEditorial ()	// show editorial of requested page
    int getAuthor ()		// show id of user who created this page
    string getStatus ()		// show status of page
    int getDirectory ()		// show id of directory
    datetime getPublished ()	// show time of publishing
 	
 * **************************************************************************** */

class ErrorPage implements PageInterface {

    private $page;

    public function __construct ()
    {

    	if ( Error::ticket () -> status == 4 ) {
    	    $this -> page [ "title" ] = _( "Kritická chyba" );
    	    $this -> page [ "editorial" ] = _( "Kritická chyba zachycená na webových stránkách." );
    	    $this -> page [ "text" ] = "<p>". _( "Při běhu stránek se objevila kritická chyba, která znemožnila běžný běh webu." ) ."</p>
    	    				<p>". _( "Omlouváme se za případné potíže a ujišťujeme Vás, že uděláme maximum, abychom problém odstranily." ) ."</p>
    	    				<p>". _( "Automatika systému už nyní udělala maximum pro informování administrátorů." ) ."</p>";
    	} else {
    	    $this -> page [ "title" ] = _( "Bezpečnostní chyba" );
    	    $this -> page [ "editorial" ] = _( "Bezpečnostní chyba zachycená na webových stránkách." );
    	    $this -> page [ "text" ] = "<p>". _( "Vaše činnost na stránkách vyvolala bezpečnostní chybu. Neopakujte prosím znovu akci,
    	    				kterou jste právě provedli." ) ."</p>
    	    				<p>". _( "Automatika systému už nyní udělala maximum pro informování administrátorů." ) ."</p>
    	    				<p>". _( "Pokud byla bezpečnostní chyba vyvolána záměrně, upozorňujeme Vás, že jsme uložili maximum
    	    				informací, které by mohly být použity k vaší identifikaci." ) ."</p>";
    	}

    } // end __construct

    public function getType ()
    {
    	return $this -> page [ "static" ];
    } // end getType

    public function getAuthor ()
    {
    	return 1;
    }
    
    public function getAccess ()
    {
    	return "rrr";
    }

    public function getStatus ()
    {
    	return "web";
    }

    public function getText ()
    {
    	return $this -> page [ "text" ];
    }

    public function getTitle ()
    {
    	return $this -> page [ "title" ];
    }

    public function getEditorial ()
    {
    	return $this -> page [ "editorial" ];
    }

    public function getDirectory ()
    {
    	return 1;
    } // end getDirectory

    public function getPublished ()
    {
    	return 0;
    } // end getPublished
    
}

?>