<?php
/* **************************************************************************** *

 * Page.inc.php									*
* @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*
 
 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 The class combines design patterns Singleton and Strategy. At the beginning
 algorithm identify type of Page and through the Singleton make available
 interaface of class for working with identified type.

 Properties:
    none
 	
 Public Methods:
    resource session ()		// method for availability of instance
    				   of Singleton
 	
 * **************************************************************************** */

class Page {

    private static $instance;

    public static function session ()
    {
	
    	if ( Error::ticket () -> status == 5 ||
    	     ( Error::ticket () -> status > 3 &&
    	     Tools::baseSettings () -> is_connected () ) ) { // critical or secure error
    	    self::$instance = null;
    	}

    	if ( self::$instance == null ) {

	    if ( Error::ticket () -> status == 5 ||
    	     	 ( Error::ticket () -> status > 3 &&
    	     	 Tools::baseSettings () -> is_connected () &&
    	     	 Tools::baseSettings () -> getSetting ( "running" ) == "true" ) ) {
	    	// error page after critical or secure error
	    	self::$instance = new ErrorPage ();
	    } elseif ( $page_type  = Database::connection () -> getResult ( "SELECT type FROM header WHERE file='". Tools::getPage () ."';" ) ) {
	    	if ( $page_type != "script" ) { // static page from database
	    	    self::$instance = new StaticPage ();
	    	} else { // dynamic or script page
	    	    self::$instance = new ScriptPage ();
	    	}
	    } else {
	    	self::$instance = new ScriptPage ( 'notfound' ); // Error 404
	    }

    	}

    	return self::$instance;
    } // end session

    private function __construct ()
    {
    } // end __construct

    private function __clone ()
    {
    } // end clone

} 
 
?>