<?php
/* **************************************************************************** *

 * PageInterface.inc.php							*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 This is interface for working with classes managing all types of pages

 Properties:
    none
 	
 Public Methods:
    string getAccess ()		// show access of requested page
    string getType ()		// show name of class
    string getText ()		// show text of requested page
    string getTitle ()		// show title of requested page
    string getEditorial ()	// show editorial of requested page
    int getAuthor ()		// show id of user who created this page
    string getStatus ()		// show status of page
    int getDirectory ()		// show id of directory
    datetime getPublished ()	// show time of publishing
 	
 * **************************************************************************** */

interface PageInterface {

    public function getType ();
    public function getAuthor ();
    public function getStatus ();
    public function getAccess ();
    public function getText ();
    public function getTitle ();
    public function getEditorial ();
    public function getDirectory ();
    public function getPublished ();

}

?>