<?php
/* **************************************************************************** *

 * Parser.php									*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 Parses all XHTML files, extends Publisher

 Properties:
    none
 	
 Public Methods:
    parserStart ( $resource, $element )		// starts parsing, $resource - file to parse, $element - element to replace
 	
 * **************************************************************************** */
 
class Parser extends Publisher {

    private static $instance = null;
 
    public static function session ()
    {
        self::$instance = new Parser ();
    	return self::$instance;
    } // end session
	
    private function __construct ()
    {
    } // end __construct

    private function __clone ()
    {
    } // end __clone
	
    public function parserStart ( $resource, $element )
    {    	
	$this -> data_array = null;
	$this -> attr_array = null;
	$this -> i = 0;
	$this -> opened = 0;
	$analysis_handler = xml_parser_create ();
	xml_set_object ( $analysis_handler, $this );
	xml_parser_set_option( $analysis_handler, XML_OPTION_CASE_FOLDING, 0);
	    
	if ( empty ( $this -> parse_only ) ) {
    	    xml_set_element_handler ( $analysis_handler, "parseAllToArrayBegin", "parseAllToArrayEnd" );
	    xml_set_character_data_handler ( $analysis_handler, "parseAllToArrayData" );
	} else {
    	    xml_set_element_handler ( $analysis_handler, "parseOnlyBegin", "parseOnlyEnd" );
	    xml_set_character_data_handler ( $analysis_handler, "parseOnlyData" );
	}
	$xml = $this -> loadData ( $resource );
	if ( !xml_parse ( $analysis_handler, $xml ) ) {
    	    $chyba = $this -> xmlError ( $analysis_handler );
    	}
    	if ( ! isset ( $chyba ) ) {
            return $this -> seekAndReplace ( $element );
	} else {
	    return false;
	}
    } // end parserStart
	
    protected function seekAndReplace ( $element )
    { 
	    $out = "";
	    $replace = "";
	    $counter = 0;
	    $i = 0;
	    $dont_write = false;
	    foreach ( $this -> data_array as $data ) {
	        if ( $data == ".".$element ) {
	            $counter++;
	        }
               if ( $counter > 0 ) {
		    if ( $data == "/" . $element ) {
			$out .= $this -> lookFor ( $replace, $my_array );
			$my_array = null;
			$replace = "";
		    } elseif ( ( $data != "." . $element ) and ( !empty( $data ) ) ) {
        	        $replace .= $data;
		        if ( is_array ( $this -> attr_array [ $i ] ) ) {
    			    foreach ( $this -> attr_array [ $i ] as $nam => $val ) {
				$my_array [ $nam ] = $val;
			    }
			    $replace .= ">";
		        }
		    }
                }
	    	if ( !$dont_write ) {
	            if ( $counter <= 0 ) {
        	    	if ( ( ! empty( $data ) ) and ( ( substr( $data, 0, 1 ) == "." ) or ( substr( $data, 0, 1 ) == "/" ) ) ) {
    	    		    if ( ( substr( $data,0,1 ) == "." ) ) {
		    	        $data = substr( $data,1 );
    			    }
	                    $out .= "<". $data;
			    if ( ! empty ( $this -> attr_array [ $i ] ) ) {
    		            	foreach ( $this -> attr_array [ $i ] as $nam => $val ) {
		                    $out .= " " . $nam . '="' .  str_replace ( '"', "'", $val ) .'"';
		            	}
			    }
			    if ( ( substr ( $this -> data_array [ $i ], 0, 1 ) == "." ) and ( substr ( $this -> data_array [ $i + 1 ], 0, 1 ) == "/" )  ) {
        			$out .= " /> \n";
    	    			$dont_write = true;
			    } else {
    			        $out .= "> \n";
			    }
	            	} else {
    		            $out .= $data;
		        }
	            }
	    	} else {
	            $dont_write = false;
	    	}
	    	if ( $data == ( "/". $element ) ) {
	            $counter--;
	    	}
	    	$i++;
	    }
	    return $out;
    } // end seekAndReplace
	
    protected function lookFor ( $ext, $attributes )
    {
	$pos = strpos ( $ext, '>' );
	if ( $pos > 0 ) {
    	    $name = substr ( $ext , 1 , $pos-1 );
    	}	
	$pos = strpos ( $name, ' ' );
	if ( $pos > 0 ) {
    	    $name = substr ( $name , 0 , $pos-1 );
    	}

    	$current_result = Database::connection () -> getResult ( "SELECT file FROM extensiontags WHERE element='$name';" );

    	if ( empty ( $current_result ) ) {
	    if ( is_array ( $attributes ) ) {
		foreach ( $attributes as $tit => $value ) {
		    if ( $tit == "notfound" ) {
		    	return str_replace ( "]", ">", str_replace ( "[", "<", $value ) );
		     }
		}
	    }
        } else {
	    $myclass = "ext_". $name;
	    $universal_object = new $myclass;
	    $val = $universal_object -> extension ( $attributes );
	}
	return $val;
    } // end lookFor
}
?>
