<?php
/* **************************************************************************** *

 * PrimaryForms.php								*
 * verze: 1.0.0									*
 * PHP verze: 5									*
 * autor: Martin Novák								*
 * programátoři: Martin Novák							*
 * poslední aktualizace: Martin Novák						*

 Popis:
 Třída obsahuje statické metody pro vytváření a práci se základními formuláři
 systému jako pro nastavení databáze nebo vytvoření uživatele.

 Vlastnosti:
    none
 	
 Veřejné API:
    none
 	
 * **************************************************************************** */

class PrimaryForms {

    public static function showDatabaseSettingsForm ( $action = "null" )
    {
    	if ( $action == "null" ) {
    	    $action = Tools::getPage () .".html";
    	}
    	
	$user = ( $setting = Tools::baseSettings () -> getSetting ( "user" ) ) ? $setting : "user";
	$pass = ( $setting = Tools::baseSettings () -> getSetting ( "pass" ) ) ? $setting : "pass";
	$dbhost = ( $setting = Tools::baseSettings () -> getSetting ( "dbhost" ) ) ? $setting : "dbhost";
	$dbname = ( $setting = Tools::baseSettings () -> getSetting ( "dbname" ) ) ? $setting : "dbname";
	
	return '<form action="'. $action .'" id="DatabaseConectionForm" method="post" enctype="application/x-www-form-urlencoded">
     	    	<fieldset>
     	    	    <legend>Nastavení databáze MySQL</legend>
     	    	    <label for="user">Uživatel: </label>
     	    	    <input type="text" size="15" id="user" name="user" maxlength="50" value="'. $user .'"
     	    	    onfocus="onFocusFormDefaultText(\''. $user .'\',this);"
     	    	    onblur="onLostFocusFormDefaultText(\''. $user .'\',this);" /><br />
     	    	    
     	    	    <label for="user">Heslo: </label>
     	    	    <input type="password" size="15" id="pass" name="pass" maxlength="50" value="'. $pass .'"
     	    	    onfocus="onFocusFormDefaultText(\''. $pass .'\',this);"
     	    	    onblur="onLostFocusFormDefaultText(\''. $pass .'\',this);" /><br />
     	    	    
     	    	    <label for="user">Host: </label>
     	    	    <input type="text" size="15" id="dbhost" name="dbhost" maxlength="50" value="'. $dbhost .'"
     	    	    onfocus="onFocusFormDefaultText(\''. $dbhost .'\',this);"
     	    	    onblur="onLostFocusFormDefaultText(\''. $dbhost .'\',this);" /><br />

     	    	    <label for="user">Název databáze: </label>
     	    	    <input type="text" size="15" id="dbname" name="dbname" maxlength="50" value="'. $dbname .'"
     	    	    onfocus="onFocusFormDefaultText(\''. $dbname .'\',this);"
     	    	    onblur="onLostFocusFormDefaultText(\''. $dbname .'\',this);" /><br />
     	    	    
     	    	    <input type="submit" value="Uložit nastavení" onclick="zahajPozadavekPOST(\''. $action .'\',\'DatabaseConectionForm\');return false;" />
             	</fieldset>
     	    </form>';
    } // end showDatabaseSettingsForm

    public static function update_mysql_settings ()
    {
    
    	if ( empty ( $_POST [ "user" ] ) || empty ( $_POST [ "pass" ] ) || empty ( $_POST [ "dbhost" ] ) || empty ( $_POST [ "dbname" ] ) ) {
     	    return false;
    	}
    	
    	$dbhost = addslashes ( $_POST [ "dbhost" ] );
    	$user = addslashes ( $_POST [ "user" ] );
    	$pass = addslashes ( $_POST [ "pass" ] );
    	$dbname = addslashes ( $_POST [ "dbname" ] );
    	
    	if ( !Tools::baseSettings () -> updateSetting ( "dbhost", $dbhost ) ) {
    	    return;
    	}
    	if ( !Tools::baseSettings () -> updateSetting ( "user", $user ) ) {
    	    return;
    	}
    	if ( !Tools::baseSettings () -> updateSetting ( "pass", $pass ) ) {
    	    return;
    	}
    	if ( !Tools::baseSettings () -> updateSetting ( "dbname", $dbname ) ) {
    	    return;
    	}
	Database::connection () -> reconnect ();
    	
    	return "<p><strong class=\"green\">Připojení k databázi MySQL bylo úspěšně nastaveno.</strong></p>";
    } // end update_mysql_settings

    public static function showUserCreationForm ( $action = "null" )
    {
    	if ( $action == "null" ) {
    	    $action = Tools::getPage () .".html";
    	}
    	
    	$password = md5 ( $_POST [ "pass" ] );
    	$nick = htmlspecialchars ( $_POST [ "nick" ] );
    	$fullname = htmlspecialchars ( $_POST [ "fullname" ] );
    	$email = htmlspecialchars ( $_POST [ "email" ] );
    	$language = htmlspecialchars ( $_POST [ "language" ] );
    	
    	$form = '<form action="'. $action .'" method="post" enctype="application/x-www-form-urlencoded" id="UserCreationForm">
     	    	<fieldset>
     	    	    <legend>Vytvoření nového uživatele</legend>
     	    	    <label for="nick">Nick: </label><input type="text" name="nick" maxlength="20" value="'. $nick .'" /><br />
     	    	    <label for="fullname">Občanské jméno: </label><input type="text" name="fullname" maxlength="40" value="'. $fullname .'" /><br />
     	    	    <label for="email">E-mail: </label><input type="text" name="email" maxlength="40" value="'. $email .'" /><br />
             	    <label for="pass">Heslo: </label><input type="password" size="15" name="pass" maxlength="25" /><br />
             	    <label for="pass2">Ověření hesla: </label><input type="password" size="15" name="pass2" maxlength="25" /><br />';
             	    
        // add working with user groups

        $form .= '<label for="language">Jazyk: </label><select name="language">
             	    	<option value="cs"'. ( ( $language == "cs" ) ? " selected=\"selected\"" : "" ) .'>čeština</option>
             	    </select><br />
             	    <input type="submit" value="Vytvořit uživatele" onclick="zahajPozadavekPOST(\''. $action .'\',\'UserCreationForm\');return false;" />
             	</fieldset>
     	    </form>';
     	    
	return $form;
	
    } // end showUserCreationForm

    public static function addNewUser ()
    {
    	if ( empty ( $_POST [ "nick" ] ) || empty ( $_POST [ "pass" ] ) || empty ( $_POST [ "pass2" ] ) ) {
    	    return false;
    	}
    	
    	if ( $_POST [ "pass" ] != $_POST [ "pass2" ] ) {
    		Error::ticket () -> notice ( 'cor00017', 'in '.__FILE__.' on line '.__LINE__, $nick );
    		return false;
    	}
    	
    	$password = md5 ( addslashes ( $_POST [ "pass" ] ) );
    	$nick = htmlspecialchars ( $_POST [ "nick" ] );
    	$fullname = htmlspecialchars ( $_POST [ "fullname" ] );
    	$language = htmlspecialchars ( $_POST [ "language" ] );
    	
    	if ( Database::connection () -> query ( "INSERT INTO users VALUES (0, '$nick', '$password', '$fullname', CURRENT_TIMESTAMP (),  0, '$language');" ) ) {
    	    if ( Tools::baseSettings () -> getSetting ( "first_administrator_created" ) != "true" ) {
    	    	// move it to instalation
    	    	if ( Database::connection () -> query ( "INSERT INTO membersofgroups VALUES ( LAST_INSERT_ID(), 1 );" ) ) {
    	    	    return '<p><strong class="green">Uživatel '. $nick .' byl úspěšně vytvořen a zaznamenán jako administrator.</strong></p>';
    	    	}
    	    }
    	    return '<p><strong class="green">Uživatel '. $nick .' byl úspěšně vytvořen.</strong></p>';
    	} else {
    	    Error::ticket () -> notice ( 'cor00018', 'in '.__FILE__.' on line '.__LINE__, $nick );
    	}
    }

} 
 
?>