<?php
/* **************************************************************************** *

 * SecurityTools.inc.php							*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 This is class containing static methods for Albireo security.

 Properties:
    none
 	
 Public Methods:
    bool check_read ( $access, $author, $group )
    				// check user permission to read
    bool check_write ( $access, $author, $group )
    				// check user permission to write
 	
 * **************************************************************************** */

class SecurityTools {

    public static function check_read ( $access, $author, $group )
    {
    	if ( empty ( $access ) || empty ( $author ) || empty ( $group ) ) {
    	    return false;
    	}
    	
    	if ( $author == User::session () -> getId () || // user is author, so he can sure read
    	     User::session () -> getPrimaryGroup () == 1 ||  // administrator can read everything
    	     ( User::session () -> getPrimaryGroup () == 2 && $group != 1 ) || // webmaster can read anything if it doesn`t belong to administrators
    	     substr ( $access, -1 ) == "r" || // in access is that all users can read it
    	     substr ( $access, -1 ) == "w" || // in access is that all users can write, so they can read it too
    	     ( substr ( $access, -2, 1 ) == "r" || substr ( $access, -2, 1 ) == "w" ) && ( Database::connection () -> getResult ( "SELECT groupid FROM membersofgroups WHERE userid=". User::session () -> getId () ." AND groupid=". (int) $group .";" ) ) ) { // user is member of needed usergroup and that user group can read
    	    return true;
    	} else {
    	    return false;
    	}
    } // end check_read

    public static function check_write ( $access, $author, $group )
    {
    	if ( User::session () -> getPrimaryGroup () == 1 || // administrator can write everywhere
    	     ( User::session () -> getPrimaryGroup () == 2 && $group != 1 ) || // webmaster can write anywhere if that doesn`t belong to administrators
    	     ( $author == User::session () -> getId () && substr ( $access, -3, 1 ) == "w" ) ||  // user is author and he can write
    	     substr ( $access, -1 ) == "w" || // in access is that all users can write, so they can read it too
    	     ( substr ( $access, -2, 1 ) == "w" && Database::connection () -> getResult ( "SELECT groupid FROM membersofgroups WHERE userid=". User::session () -> getId () ." AND groupid=". (int) $group .";" ) ) ) {
    	    return true;
    	} else {
    	    return false;
    	}
    } // end check_write
 
}

?>