<?php
/* **************************************************************************** *

 * Tools.inc.php								*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 This is class containing only basic static methods for common using.

 Properties:
    none
 	
 Public Methods:
    string getPage ()		// show web requested file
    string getRightDate ( $date )
    				// on input is date with database format and
    				   function returns human date
    resource baseSettings ()	// get resource of class Settings for working
    				   with basic Albireo settings
 	
 * **************************************************************************** */

class Tools {

    private static $BaseSettings;
    private static $DialogJSInserted = false;

    public static function getPage ()
    {
    	if ( isset ( $_GET [ "page" ] ) ) {
    	    return addslashes ( urldecode ( $_GET [ "page" ] ) );
    	} else {
    	    return Localization::session() -> getLanguage () ."_index";
    	}
    } // end getPage

    public static function getFullPage ()
    {
    	if ( isset ( $_GET [ "page" ] ) ) {
    	    return addslashes ( urldecode ( $_GET [ "page" ] ) ) . Tools::baseSettings () -> getSetting ( "file_extension" );
    	} else {
    	    return Localization::session() -> getLanguage () ."_index". Tools::baseSettings () -> getSetting ( "file_extension" );
    	}
    } // end getPage

    public static function getRightDate ( $date, $type = "short" )
    {
    	if ( $type == "short" ) {
    	    return intval ( substr ( $date, 8, 2 ) ) .".". intval ( substr ( $date, 5, 2 ) ). ".". substr ( $date, 0, 4 );
    	} else { // that meand $type contents "long", "full" or similar thing
    	    return intval ( substr ( $date, 8, 2 ) ) .".". intval ( substr ( $date, 5, 2 ) ). ".". substr ( $date, 0, 4 ) ." "
    	    . substr ( $date, 11, 8 );
    	}
    } // end getRightDate

    public static function baseSettings ()
    {
    	if ( self::$BaseSettings == null ) {
    	    self::$BaseSettings = new Settings ( "base-settings" );
    	}
    	return self::$BaseSettings;
    } // end baseSettings
 
}

?>