<?php
/* **************************************************************************** *

 * AlbireoUser.inc.php								*
 * @version: 	1.0.0								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software! This file may have been modified pursuant to the	*
 * GNU General Public License, and as distributed it includes or is derivative	*
 * of works licensed under the GNU General Public License or other free or open	*
 * source software licenses.							*

 This script description:
 Class UnknownUser is called by class User for managing users without login and
 any type of tracking.

 Properties:
    none
 	
 Public Methods:
    string getType ()		// show name of class
    string getUserType ()	// show type of user
    string getNick ()		// show nick of user
    string getFullName ()	// show full name of user
    string getEmail ()		// show e-mail of user
    string getLanguage ()	// show language of user`s interface
    int getId ()		// show id of user
    datetime getRegistered ()	// show time of registering
 	
 * **************************************************************************** */

class UnknownUser implements UserInterface {

    public function __construct () {
    } // end __construct

    public function getFullName ()
    {
    	return _( "Neznámý Uživatel" );
    } // end getFullName

    public function getId ()
    {
    	return 0;
    } // end getId

    public function getNick ()
    {
    	return _( "Anonym" );
    } // end getNick

    public function getUserType ()
    {
    	return "guest";
    } // end getUserType

    public function getType ()
    {
    	return "UnknownUser";
    } // end getType

    public function getPrimaryGroup ()
    {
    	return 0;
    } // end getPrimaryGroup

    public function getLanguage ()
    {
    	return Localization::session () -> getLanguage ();
    } // end getLanguage

    public function getEmail ()
    {
    	return 0;
    } // end getEmail

}

?>