<?php
/* **************************************************************************** *

 * User.inc.php									*
 * @package	Core								*
 * @copyright:	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*
 
 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 The class combines design patterns Singleton and Strategy. At the beginning
 algorithm identify type of user and through the Singleton make available
 interaface of class for working with identified type.

 Properties:
    none
 	
 Public Methods:
    resource session ()		// method for availability of instance
    				   of Singleton
 	
 * **************************************************************************** */
 
class User {

    private static $instance;

    public static function session ()
    {
    
    	if ( self::$instance == null ) {
    	
    	    if ( AlbireoUser::isLogedIn () ) {
    	        // loged user of Albireo administration system
    	        self::$instance = new AlbireoUser ();
    	    } elseif ( isset ( $_COOKIE [ "sessionid" ] ) && $_COOKIE [ "sessionid" ] != 0 ) {
    	        // from cookie, It hasn`t benn programmed yet
    	    } else {
    	        // unknown user without login and any type of tracking
    	        self::$instance = new UnknownUser ();
    	    }
    	    
    	}
    	
    	return self::$instance;
    	
    } // end session

    private function __construct ()
    {
    } // end __construct

    private function __clone ()
    {
    } // end clone

}
 
?>