<?php
/* **************************************************************************** *

 * W4CErrorPage.php									*
 * verze: 1.0.0									*
 * PHP verze: 5									*
 * autor: Martin Novák								*
 * programátoři: Martin Novák							*
 * poslední aktualizace: Martin Novák						*

 Popis:
 Třída W4CErrorPage je volána po přerušení běžného běhu po vyvolání kritické
 nebo bezpečnostní chyby.

 Vlastnosti:
    none

 Veřejné API:
    none
    
 * **************************************************************************** */

class W4CErrorPage implements W4CPage {

    private $page;
    private $soubor;

    public function __construct ()
    {
    	$this -> soubor = Tools::getPage ();  // načte url jméno požadované stránky
    	if ( Error::ticket () -> status == 4 ) {
    	    $this -> page [ "title" ] = "Kritická chyba";
    	    $this -> page [ "editorial" ] = "Kritická chyba zachycená na webových stránkách.";
    	    $this -> page [ "text" ] = "<p>Při běhu stránek se objevila kritická chyba, která znemožnila běžný běh webu.</p>
    	    				<p>Omlouváme se za případné potíže a ujišťujeme Vás, že uděláme maximum, abychom problém odstranily.</p>
    	    				<p>Automatika systému už nyní udělala maximum pro informování administrátorů.";
    	} else {
    	    $this -> page [ "title" ] = "Bezpečnostní chyba";
    	    $this -> page [ "editorial" ] = "Bezpečnostní chyba zachycená na webových stránkách.";
    	    $this -> page [ "text" ] = "<p>Vaše činnost na stránkách vyvolala bezpečnostní chybu. Neopakujte prosím znovu akci,
    	    				kterou jste právě provedli.
    	    				<p>Automatika systému už nyní udělala maximum pro informování administrátorů.</p>
    	    				<p>Pokud byla bezpečnostní chyba vyvolána záměrně, upozorňujeme vás, že jsme uložili maximum
    	    				informací, které by mohly být použity k vaší identifikaci.</p>";
    	}
	    	
    } // end __construct

    public function getAccess () {
    	return 'public';
    }

    public function getStructure () {
	return 0;
    }
    
    public function getSubcategory () {
    	return 0;
    }

    public function showType ()
    {
    	return "W4CErrorPage";
    }
	
	public function getSoubor ()
    {
    	return Tools::getPage ();
    }

    public function getStatus ()
    {
    	return "web";
    }

    public function getCategory ()
    {
    	return 0;
    }

    public function getText ()
    {
    	return $this -> page [ "text" ];
    }

    public function getTitle ()
    {
    	return $this -> page [ "title" ];
    }

    public function getEditorial ()
    {
    	return $this -> page [ "editorial" ];
    }

    public function getAuthor ()
    {
    	return 0;
    }
    
}

?>