/* **************************************************************************** *

 * cor-ajax-base.js								*
 * @package	Core								*
 * @copyright:	Copyright (c) 2007 - 2008 Ragnar.cz. All rights reserved	*
 * @license	GNU/GPL http://www.gnu.org/copyleft/gpl.html			*
 
 * Albireo is free software!							*
 	
 * **************************************************************************** */

    // MSIE doesn't know XMLHttpRequest that opens Ajax in rest of browsers,
    // so we will create it from ActiveXObject
    if ( typeof XMLHttpRequest == "undefined" ) {
    	XMLHttpRequest = function () {
    	    return new ActiveXObject (
    	    	// MSIE 5 uses for Ajax object different from next versions
    	    	navigator.userAgent.indexOf ( "MSIE 5" ) >= 0 ?
    	    	"Microsoft.XMLHTTP" : "Msxml2.XMLHTTP"
    	    );
    	};
    }

    // is called for checking http states in ajax triggers
    function httpSuccess ( r ) {

    	try {
    	    // no status means local file and the request succeeded
    	    return !r.status && location.protocol == "file:" ||
    	    	// all status from 200 to 299 is good
    	    	( r.status >= 200 && r.status < 300 ) ||
    	    	// document hasn`t changed, successful end
    	    	r.status == 304 ||
    	    	// browser Safari sends blank status for unchanged documents
    	    	navigator.userAgent.indexOf ( "Safari" ) >= 0 && typeof r.status == "undefined";
    	} catch ( e ) {}

	// exception means unsuccessful end
    	return false;
    }

    // next function will change element by Ajax response
    function changeIdByAjax ( xmlhttp, id ) {//window.alert (xmlhttp.responseText);
    	if ( xmlhttp.responseText.indexOf ( "<body>" ) != -1 ) {
    	    $( document.getElementById ( id ) ).css ( "display", "none" );
    	    $( document.getElementById ( id ) ).fadeIn ( 500 );
    	    // we work with xml response as text becouse browsers (aside from Firefox) can`t append xml tags as html into document
    	    var response = xmlhttp.responseText.substring ( xmlhttp.responseText.indexOf ( "<body>" )+6, xmlhttp.responseText.indexOf ( "</body>" ) );
	    document.getElementById ( id ).innerHTML = response;

	} else {
	    document.getElementById ( id ).innerHTML = '<p><strong class="warning">Response has no contents!</strong>';
	}

	xmlhttp = null;
    }

    // function for showing and hiding messages. It`s good for combinating with ajax
    function showAndHide ( id ) {
    	if ( document.getElementById ( id ) ) {
    	    $( document.getElementById ( id ) ).fadeIn ( "slow" );
    	    setTimeout ( function () {
	    	$( document.getElementById ( id ) ).fadeOut ( "slow" );
	    }, 6000 );
    	}
    }